/* cpu-monitor.c generated by valac 0.56.18, the Vala compiler
 * generated from cpu-monitor.vala, do not modify */

/* cpu-monitor.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glibtop/cpu.h>
#include <glibtop.h>
#include <glibtop/proctime.h>
#include <glibtop/procstate.h>
#include <gobject/gvaluecollector.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define USAGE_TYPE_MONITOR (usage_monitor_get_type ())
#define USAGE_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_MONITOR, UsageMonitor))
#define USAGE_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_MONITOR))
#define USAGE_MONITOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), USAGE_TYPE_MONITOR, UsageMonitorIface))

typedef struct _UsageMonitor UsageMonitor;
typedef struct _UsageMonitorIface UsageMonitorIface;

#define USAGE_TYPE_PROCESS (usage_process_get_type ())
#define USAGE_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_PROCESS, UsageProcess))
#define USAGE_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_PROCESS, UsageProcessClass))
#define USAGE_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_PROCESS))
#define USAGE_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_PROCESS))
#define USAGE_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_PROCESS, UsageProcessClass))

typedef struct _UsageProcess UsageProcess;
typedef struct _UsageProcessClass UsageProcessClass;

#define USAGE_TYPE_CPU_MONITOR (usage_cpu_monitor_get_type ())
#define USAGE_CPU_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_CPU_MONITOR, UsageCpuMonitor))
#define USAGE_CPU_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_CPU_MONITOR, UsageCpuMonitorClass))
#define USAGE_IS_CPU_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_CPU_MONITOR))
#define USAGE_IS_CPU_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_CPU_MONITOR))
#define USAGE_CPU_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_CPU_MONITOR, UsageCpuMonitorClass))

typedef struct _UsageCpuMonitor UsageCpuMonitor;
typedef struct _UsageCpuMonitorClass UsageCpuMonitorClass;
typedef struct _UsageCpuMonitorPrivate UsageCpuMonitorPrivate;
typedef struct _UsageParamSpecCpuMonitor UsageParamSpecCpuMonitor;

struct _UsageMonitorIface {
	GTypeInterface parent_iface;
	void (*update) (UsageMonitor* self);
	void (*update_process) (UsageMonitor* self, UsageProcess** process);
};

struct _UsageCpuMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UsageCpuMonitorPrivate * priv;
};

struct _UsageCpuMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (UsageCpuMonitor *self);
};

struct _UsageCpuMonitorPrivate {
	gdouble cpu_load;
	gdouble* x_cpu_load;
	gint x_cpu_load_length1;
	gint _x_cpu_load_size_;
	guint64 cpu_last_used;
	guint64 cpu_last_total;
	guint64 cpu_last_total_step;
	guint64* x_cpu_last_used;
	gint x_cpu_last_used_length1;
	gint _x_cpu_last_used_size_;
	guint64* x_cpu_last_total;
	gint x_cpu_last_total_length1;
	gint _x_cpu_last_total_size_;
};

struct _UsageParamSpecCpuMonitor {
	GParamSpec parent_instance;
};

static gint UsageCpuMonitor_private_offset;
static gpointer usage_cpu_monitor_parent_class = NULL;
static UsageMonitorIface * usage_cpu_monitor_usage_monitor_parent_iface = NULL;

VALA_EXTERN GType usage_process_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageProcess, g_object_unref)
VALA_EXTERN GType usage_monitor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer usage_cpu_monitor_ref (gpointer instance);
VALA_EXTERN void usage_cpu_monitor_unref (gpointer instance);
VALA_EXTERN GParamSpec* usage_param_spec_cpu_monitor (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void usage_value_set_cpu_monitor (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void usage_value_take_cpu_monitor (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer usage_value_get_cpu_monitor (const GValue* value);
VALA_EXTERN GType usage_cpu_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageCpuMonitor, usage_cpu_monitor_unref)
VALA_EXTERN UsageCpuMonitor* usage_cpu_monitor_new (void);
VALA_EXTERN UsageCpuMonitor* usage_cpu_monitor_construct (GType object_type);
static void usage_cpu_monitor_real_update (UsageMonitor* base);
static guint64* _vala_array_dup3 (guint64* self,
                           gssize length);
static guint64* _vala_array_dup4 (guint64* self,
                           gssize length);
VALA_EXTERN gdouble usage_cpu_monitor_get_cpu_load (UsageCpuMonitor* self);
VALA_EXTERN gdouble* usage_cpu_monitor_get_x_cpu_load (UsageCpuMonitor* self,
                                           gint* result_length1);
static gdouble* _vala_array_dup5 (gdouble* self,
                           gssize length);
static void usage_cpu_monitor_real_update_process (UsageMonitor* base,
                                            UsageProcess** process);
VALA_EXTERN GPid usage_process_get_pid (UsageProcess* self);
VALA_EXTERN void usage_process_set_last_processor (UsageProcess* self,
                                       guint value);
VALA_EXTERN guint64 usage_process_get_cpu_last_used (UsageProcess* self);
VALA_EXTERN void usage_process_set_cpu_load (UsageProcess* self,
                                 gdouble value);
VALA_EXTERN void usage_process_set_cpu_last_used (UsageProcess* self,
                                      guint64 value);
VALA_EXTERN guint usage_process_get_last_processor (UsageProcess* self);
VALA_EXTERN void usage_process_set_x_cpu_last_used (UsageProcess* self,
                                        guint64 value);
VALA_EXTERN void usage_process_set_start_time (UsageProcess* self,
                                   guint64 value);
VALA_EXTERN void usage_monitor_update (UsageMonitor* self);
VALA_EXTERN void usage_monitor_update_process (UsageMonitor* self,
                                   UsageProcess** process);
static void usage_cpu_monitor_finalize (UsageCpuMonitor * obj);
static GType usage_cpu_monitor_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
usage_cpu_monitor_get_instance_private (UsageCpuMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, UsageCpuMonitor_private_offset);
}

UsageCpuMonitor*
usage_cpu_monitor_construct (GType object_type)
{
	UsageCpuMonitor* self = NULL;
	gdouble* _tmp0_;
	guint64* _tmp1_;
	guint64* _tmp2_;
#line 30 "../src/cpu-monitor.vala"
	self = (UsageCpuMonitor*) g_type_create_instance (object_type);
#line 31 "../src/cpu-monitor.vala"
	_tmp0_ = g_new0 (gdouble, g_get_num_processors ());
#line 31 "../src/cpu-monitor.vala"
	self->priv->x_cpu_load = (g_free (self->priv->x_cpu_load), NULL);
#line 31 "../src/cpu-monitor.vala"
	self->priv->x_cpu_load = _tmp0_;
#line 31 "../src/cpu-monitor.vala"
	self->priv->x_cpu_load_length1 = g_get_num_processors ();
#line 31 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_load_size_ = self->priv->x_cpu_load_length1;
#line 32 "../src/cpu-monitor.vala"
	_tmp1_ = g_new0 (guint64, g_get_num_processors ());
#line 32 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = (g_free (self->priv->x_cpu_last_used), NULL);
#line 32 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = _tmp1_;
#line 32 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used_length1 = g_get_num_processors ();
#line 32 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_last_used_size_ = self->priv->x_cpu_last_used_length1;
#line 33 "../src/cpu-monitor.vala"
	_tmp2_ = g_new0 (guint64, g_get_num_processors ());
#line 33 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = (g_free (self->priv->x_cpu_last_total), NULL);
#line 33 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = _tmp2_;
#line 33 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total_length1 = g_get_num_processors ();
#line 33 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_last_total_size_ = self->priv->x_cpu_last_total_length1;
#line 30 "../src/cpu-monitor.vala"
	return self;
#line 224 "cpu-monitor.c"
}

UsageCpuMonitor*
usage_cpu_monitor_new (void)
{
#line 30 "../src/cpu-monitor.vala"
	return usage_cpu_monitor_construct (USAGE_TYPE_CPU_MONITOR);
#line 232 "cpu-monitor.c"
}

static guint64*
_vala_array_dup3 (guint64* self,
                  gssize length)
{
#line 51 "../src/cpu-monitor.vala"
	if (length > 0) {
#line 51 "../src/cpu-monitor.vala"
		return _vala_memdup2 (self, length * sizeof (guint64));
#line 243 "cpu-monitor.c"
	}
#line 51 "../src/cpu-monitor.vala"
	return NULL;
#line 247 "cpu-monitor.c"
}

static guint64*
_vala_array_dup4 (guint64* self,
                  gssize length)
{
#line 52 "../src/cpu-monitor.vala"
	if (length > 0) {
#line 52 "../src/cpu-monitor.vala"
		return _vala_memdup2 (self, length * sizeof (guint64));
#line 258 "cpu-monitor.c"
	}
#line 52 "../src/cpu-monitor.vala"
	return NULL;
#line 262 "cpu-monitor.c"
}

static void
usage_cpu_monitor_real_update (UsageMonitor* base)
{
	UsageCpuMonitor * self;
	glibtop_cpu cpu_data = {0};
	glibtop_cpu _tmp0_ = {0};
	guint64 used = 0ULL;
	glibtop_cpu _tmp1_;
	glibtop_cpu _tmp2_;
	glibtop_cpu _tmp3_;
	glibtop_cpu _tmp4_;
	glibtop_cpu _tmp5_;
	guint64* x_cpu_used = NULL;
	guint64* _tmp6_;
	gint x_cpu_used_length1;
	gint _x_cpu_used_size_;
	glibtop_cpu _tmp26_;
	guint64* _tmp27_;
	gint _tmp27__length1;
	guint64* _tmp28_;
	gint _tmp28__length1;
	glibtop_cpu _tmp29_;
	guint64* _tmp30_;
	gint _tmp30__length1;
#line 36 "../src/cpu-monitor.vala"
	self = (UsageCpuMonitor*) base;
#line 38 "../src/cpu-monitor.vala"
	glibtop_get_cpu (&_tmp0_);
#line 38 "../src/cpu-monitor.vala"
	cpu_data = _tmp0_;
#line 39 "../src/cpu-monitor.vala"
	_tmp1_ = cpu_data;
#line 39 "../src/cpu-monitor.vala"
	_tmp2_ = cpu_data;
#line 39 "../src/cpu-monitor.vala"
	_tmp3_ = cpu_data;
#line 39 "../src/cpu-monitor.vala"
	used = (_tmp1_.user + _tmp2_.nice) + _tmp3_.sys;
#line 40 "../src/cpu-monitor.vala"
	_tmp4_ = cpu_data;
#line 40 "../src/cpu-monitor.vala"
	self->priv->cpu_load = ((gdouble) (used - self->priv->cpu_last_used)) / (_tmp4_.total - self->priv->cpu_last_total);
#line 41 "../src/cpu-monitor.vala"
	_tmp5_ = cpu_data;
#line 41 "../src/cpu-monitor.vala"
	self->priv->cpu_last_total_step = _tmp5_.total - self->priv->cpu_last_total;
#line 43 "../src/cpu-monitor.vala"
	_tmp6_ = g_new0 (guint64, g_get_num_processors ());
#line 43 "../src/cpu-monitor.vala"
	x_cpu_used = _tmp6_;
#line 43 "../src/cpu-monitor.vala"
	x_cpu_used_length1 = g_get_num_processors ();
#line 43 "../src/cpu-monitor.vala"
	_x_cpu_used_size_ = x_cpu_used_length1;
#line 319 "cpu-monitor.c"
	{
		gint i = 0;
#line 44 "../src/cpu-monitor.vala"
		i = 0;
#line 324 "cpu-monitor.c"
		{
			gboolean _tmp7_ = FALSE;
#line 44 "../src/cpu-monitor.vala"
			_tmp7_ = TRUE;
#line 44 "../src/cpu-monitor.vala"
			while (TRUE) {
#line 331 "cpu-monitor.c"
				gdouble* _tmp9_;
				gint _tmp9__length1;
				guint64* _tmp10_;
				gint _tmp10__length1;
				glibtop_cpu _tmp11_;
				guint64 _tmp12_;
				glibtop_cpu _tmp13_;
				guint64 _tmp14_;
				glibtop_cpu _tmp15_;
				guint64 _tmp16_;
				gdouble* _tmp17_;
				gint _tmp17__length1;
				guint64* _tmp18_;
				gint _tmp18__length1;
				guint64 _tmp19_;
				guint64* _tmp20_;
				gint _tmp20__length1;
				guint64 _tmp21_;
				glibtop_cpu _tmp22_;
				guint64 _tmp23_;
				guint64* _tmp24_;
				gint _tmp24__length1;
				guint64 _tmp25_;
#line 44 "../src/cpu-monitor.vala"
				if (!_tmp7_) {
#line 357 "cpu-monitor.c"
					gint _tmp8_;
#line 44 "../src/cpu-monitor.vala"
					_tmp8_ = i;
#line 44 "../src/cpu-monitor.vala"
					i = _tmp8_ + 1;
#line 363 "cpu-monitor.c"
				}
#line 44 "../src/cpu-monitor.vala"
				_tmp7_ = FALSE;
#line 44 "../src/cpu-monitor.vala"
				_tmp9_ = self->priv->x_cpu_load;
#line 44 "../src/cpu-monitor.vala"
				_tmp9__length1 = self->priv->x_cpu_load_length1;
#line 44 "../src/cpu-monitor.vala"
				if (!(i < _tmp9__length1)) {
#line 44 "../src/cpu-monitor.vala"
					break;
#line 375 "cpu-monitor.c"
				}
#line 45 "../src/cpu-monitor.vala"
				_tmp10_ = x_cpu_used;
#line 45 "../src/cpu-monitor.vala"
				_tmp10__length1 = x_cpu_used_length1;
#line 45 "../src/cpu-monitor.vala"
				_tmp11_ = cpu_data;
#line 45 "../src/cpu-monitor.vala"
				_tmp12_ = _tmp11_.xcpu_user[i];
#line 45 "../src/cpu-monitor.vala"
				_tmp13_ = cpu_data;
#line 45 "../src/cpu-monitor.vala"
				_tmp14_ = _tmp13_.xcpu_nice[i];
#line 45 "../src/cpu-monitor.vala"
				_tmp15_ = cpu_data;
#line 45 "../src/cpu-monitor.vala"
				_tmp16_ = _tmp15_.xcpu_sys[i];
#line 45 "../src/cpu-monitor.vala"
				_tmp10_[i] = (_tmp12_ + _tmp14_) + _tmp16_;
#line 46 "../src/cpu-monitor.vala"
				_tmp17_ = self->priv->x_cpu_load;
#line 46 "../src/cpu-monitor.vala"
				_tmp17__length1 = self->priv->x_cpu_load_length1;
#line 46 "../src/cpu-monitor.vala"
				_tmp18_ = x_cpu_used;
#line 46 "../src/cpu-monitor.vala"
				_tmp18__length1 = x_cpu_used_length1;
#line 46 "../src/cpu-monitor.vala"
				_tmp19_ = _tmp18_[i];
#line 46 "../src/cpu-monitor.vala"
				_tmp20_ = self->priv->x_cpu_last_used;
#line 46 "../src/cpu-monitor.vala"
				_tmp20__length1 = self->priv->x_cpu_last_used_length1;
#line 46 "../src/cpu-monitor.vala"
				_tmp21_ = _tmp20_[i];
#line 46 "../src/cpu-monitor.vala"
				_tmp22_ = cpu_data;
#line 46 "../src/cpu-monitor.vala"
				_tmp23_ = _tmp22_.xcpu_total[i];
#line 46 "../src/cpu-monitor.vala"
				_tmp24_ = self->priv->x_cpu_last_total;
#line 46 "../src/cpu-monitor.vala"
				_tmp24__length1 = self->priv->x_cpu_last_total_length1;
#line 46 "../src/cpu-monitor.vala"
				_tmp25_ = _tmp24_[i];
#line 46 "../src/cpu-monitor.vala"
				_tmp17_[i] = ((gdouble) (_tmp19_ - _tmp21_)) / (_tmp23_ - _tmp25_);
#line 423 "cpu-monitor.c"
			}
		}
	}
#line 49 "../src/cpu-monitor.vala"
	self->priv->cpu_last_used = used;
#line 50 "../src/cpu-monitor.vala"
	_tmp26_ = cpu_data;
#line 50 "../src/cpu-monitor.vala"
	self->priv->cpu_last_total = _tmp26_.total;
#line 51 "../src/cpu-monitor.vala"
	_tmp27_ = x_cpu_used;
#line 51 "../src/cpu-monitor.vala"
	_tmp27__length1 = x_cpu_used_length1;
#line 51 "../src/cpu-monitor.vala"
	_tmp28_ = (_tmp27_ != NULL) ? _vala_array_dup3 (_tmp27_, _tmp27__length1) : _tmp27_;
#line 51 "../src/cpu-monitor.vala"
	_tmp28__length1 = _tmp27__length1;
#line 51 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = (g_free (self->priv->x_cpu_last_used), NULL);
#line 51 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = _tmp28_;
#line 51 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used_length1 = _tmp28__length1;
#line 51 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_last_used_size_ = self->priv->x_cpu_last_used_length1;
#line 52 "../src/cpu-monitor.vala"
	_tmp29_ = cpu_data;
#line 52 "../src/cpu-monitor.vala"
	_tmp30_ = _vala_array_dup4 (_tmp29_.xcpu_total, 1024);
#line 52 "../src/cpu-monitor.vala"
	_tmp30__length1 = 1024;
#line 52 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = (g_free (self->priv->x_cpu_last_total), NULL);
#line 52 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = _tmp30_;
#line 52 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total_length1 = _tmp30__length1;
#line 52 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_last_total_size_ = self->priv->x_cpu_last_total_length1;
#line 36 "../src/cpu-monitor.vala"
	x_cpu_used = (g_free (x_cpu_used), NULL);
#line 465 "cpu-monitor.c"
}

gdouble
usage_cpu_monitor_get_cpu_load (UsageCpuMonitor* self)
{
	gdouble result;
#line 55 "../src/cpu-monitor.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 56 "../src/cpu-monitor.vala"
	result = self->priv->cpu_load;
#line 56 "../src/cpu-monitor.vala"
	return result;
#line 478 "cpu-monitor.c"
}

static gdouble*
_vala_array_dup5 (gdouble* self,
                  gssize length)
{
#line 60 "../src/cpu-monitor.vala"
	if (length > 0) {
#line 60 "../src/cpu-monitor.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 489 "cpu-monitor.c"
	}
#line 60 "../src/cpu-monitor.vala"
	return NULL;
#line 493 "cpu-monitor.c"
}

gdouble*
usage_cpu_monitor_get_x_cpu_load (UsageCpuMonitor* self,
                                  gint* result_length1)
{
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gdouble* result;
#line 59 "../src/cpu-monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/cpu-monitor.vala"
	_tmp0_ = self->priv->x_cpu_load;
#line 60 "../src/cpu-monitor.vala"
	_tmp0__length1 = self->priv->x_cpu_load_length1;
#line 60 "../src/cpu-monitor.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup5 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 60 "../src/cpu-monitor.vala"
	_tmp1__length1 = _tmp0__length1;
#line 60 "../src/cpu-monitor.vala"
	_tmp2_ = _tmp1_;
#line 60 "../src/cpu-monitor.vala"
	_tmp2__length1 = _tmp1__length1;
#line 60 "../src/cpu-monitor.vala"
	if (result_length1) {
#line 60 "../src/cpu-monitor.vala"
		*result_length1 = _tmp2__length1;
#line 525 "cpu-monitor.c"
	}
#line 60 "../src/cpu-monitor.vala"
	result = _tmp2_;
#line 60 "../src/cpu-monitor.vala"
	return result;
#line 531 "cpu-monitor.c"
}

static void
usage_cpu_monitor_real_update_process (UsageMonitor* base,
                                       UsageProcess** process)
{
	UsageCpuMonitor * self;
	glibtop_proc_time proc_time = {0};
	glibtop_proc_state proc_state = {0};
	GPid _tmp0_;
	GPid _tmp1_;
	glibtop_proc_time _tmp2_ = {0};
	GPid _tmp3_;
	GPid _tmp4_;
	glibtop_proc_state _tmp5_ = {0};
	glibtop_proc_state _tmp6_;
	gdouble cpu_load = 0.0;
	glibtop_proc_time _tmp7_;
	guint64 _tmp8_;
	guint64 _tmp9_;
	glibtop_proc_time _tmp10_;
	glibtop_proc_time _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	guint64 _tmp14_;
	glibtop_proc_time _tmp15_;
	guint _tmp16_;
	guint _tmp17_;
	guint64 _tmp18_;
	glibtop_proc_time _tmp19_;
#line 63 "../src/cpu-monitor.vala"
	self = (UsageCpuMonitor*) base;
#line 63 "../src/cpu-monitor.vala"
	g_return_if_fail (*process != NULL);
#line 67 "../src/cpu-monitor.vala"
	_tmp0_ = usage_process_get_pid (*process);
#line 67 "../src/cpu-monitor.vala"
	_tmp1_ = _tmp0_;
#line 67 "../src/cpu-monitor.vala"
	glibtop_get_proc_time (&_tmp2_, _tmp1_);
#line 67 "../src/cpu-monitor.vala"
	proc_time = _tmp2_;
#line 68 "../src/cpu-monitor.vala"
	_tmp3_ = usage_process_get_pid (*process);
#line 68 "../src/cpu-monitor.vala"
	_tmp4_ = _tmp3_;
#line 68 "../src/cpu-monitor.vala"
	glibtop_get_proc_state (&_tmp5_, _tmp4_);
#line 68 "../src/cpu-monitor.vala"
	proc_state = _tmp5_;
#line 70 "../src/cpu-monitor.vala"
	_tmp6_ = proc_state;
#line 70 "../src/cpu-monitor.vala"
	usage_process_set_last_processor (*process, (guint) _tmp6_.last_processor);
#line 71 "../src/cpu-monitor.vala"
	_tmp7_ = proc_time;
#line 71 "../src/cpu-monitor.vala"
	_tmp8_ = usage_process_get_cpu_last_used (*process);
#line 71 "../src/cpu-monitor.vala"
	_tmp9_ = _tmp8_;
#line 71 "../src/cpu-monitor.vala"
	cpu_load = ((gdouble) (_tmp7_.rtime - _tmp9_)) / self->priv->cpu_last_total_step;
#line 72 "../src/cpu-monitor.vala"
	usage_process_set_cpu_load (*process, MIN ((gdouble) 1, cpu_load));
#line 73 "../src/cpu-monitor.vala"
	_tmp10_ = proc_time;
#line 73 "../src/cpu-monitor.vala"
	usage_process_set_cpu_last_used (*process, _tmp10_.rtime);
#line 74 "../src/cpu-monitor.vala"
	_tmp11_ = proc_time;
#line 74 "../src/cpu-monitor.vala"
	_tmp12_ = usage_process_get_last_processor (*process);
#line 74 "../src/cpu-monitor.vala"
	_tmp13_ = _tmp12_;
#line 74 "../src/cpu-monitor.vala"
	_tmp14_ = _tmp11_.xcpu_utime[_tmp13_];
#line 74 "../src/cpu-monitor.vala"
	_tmp15_ = proc_time;
#line 74 "../src/cpu-monitor.vala"
	_tmp16_ = usage_process_get_last_processor (*process);
#line 74 "../src/cpu-monitor.vala"
	_tmp17_ = _tmp16_;
#line 74 "../src/cpu-monitor.vala"
	_tmp18_ = _tmp15_.xcpu_stime[_tmp17_];
#line 74 "../src/cpu-monitor.vala"
	usage_process_set_x_cpu_last_used (*process, _tmp14_ + _tmp18_);
#line 75 "../src/cpu-monitor.vala"
	_tmp19_ = proc_time;
#line 75 "../src/cpu-monitor.vala"
	usage_process_set_start_time (*process, _tmp19_.start_time);
#line 622 "cpu-monitor.c"
}

static void
usage_value_cpu_monitor_init (GValue* value)
{
#line 21 "../src/cpu-monitor.vala"
	value->data[0].v_pointer = NULL;
#line 630 "cpu-monitor.c"
}

static void
usage_value_cpu_monitor_free_value (GValue* value)
{
#line 21 "../src/cpu-monitor.vala"
	if (value->data[0].v_pointer) {
#line 21 "../src/cpu-monitor.vala"
		usage_cpu_monitor_unref (value->data[0].v_pointer);
#line 640 "cpu-monitor.c"
	}
}

static void
usage_value_cpu_monitor_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 21 "../src/cpu-monitor.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../src/cpu-monitor.vala"
		dest_value->data[0].v_pointer = usage_cpu_monitor_ref (src_value->data[0].v_pointer);
#line 652 "cpu-monitor.c"
	} else {
#line 21 "../src/cpu-monitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 656 "cpu-monitor.c"
	}
}

static gpointer
usage_value_cpu_monitor_peek_pointer (const GValue* value)
{
#line 21 "../src/cpu-monitor.vala"
	return value->data[0].v_pointer;
#line 665 "cpu-monitor.c"
}

static gchar*
usage_value_cpu_monitor_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 21 "../src/cpu-monitor.vala"
	if (collect_values[0].v_pointer) {
#line 676 "cpu-monitor.c"
		UsageCpuMonitor * object;
		object = collect_values[0].v_pointer;
#line 21 "../src/cpu-monitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../src/cpu-monitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 683 "cpu-monitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../src/cpu-monitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 687 "cpu-monitor.c"
		}
#line 21 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = usage_cpu_monitor_ref (object);
#line 691 "cpu-monitor.c"
	} else {
#line 21 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = NULL;
#line 695 "cpu-monitor.c"
	}
#line 21 "../src/cpu-monitor.vala"
	return NULL;
#line 699 "cpu-monitor.c"
}

static gchar*
usage_value_cpu_monitor_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	UsageCpuMonitor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../src/cpu-monitor.vala"
	if (!object_p) {
#line 21 "../src/cpu-monitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 714 "cpu-monitor.c"
	}
#line 21 "../src/cpu-monitor.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../src/cpu-monitor.vala"
		*object_p = NULL;
#line 720 "cpu-monitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../src/cpu-monitor.vala"
		*object_p = value->data[0].v_pointer;
#line 724 "cpu-monitor.c"
	} else {
#line 21 "../src/cpu-monitor.vala"
		*object_p = usage_cpu_monitor_ref (value->data[0].v_pointer);
#line 728 "cpu-monitor.c"
	}
#line 21 "../src/cpu-monitor.vala"
	return NULL;
#line 732 "cpu-monitor.c"
}

GParamSpec*
usage_param_spec_cpu_monitor (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	UsageParamSpecCpuMonitor* spec;
#line 21 "../src/cpu-monitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, USAGE_TYPE_CPU_MONITOR), NULL);
#line 21 "../src/cpu-monitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../src/cpu-monitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../src/cpu-monitor.vala"
	return G_PARAM_SPEC (spec);
#line 751 "cpu-monitor.c"
}

gpointer
usage_value_get_cpu_monitor (const GValue* value)
{
#line 21 "../src/cpu-monitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_CPU_MONITOR), NULL);
#line 21 "../src/cpu-monitor.vala"
	return value->data[0].v_pointer;
#line 761 "cpu-monitor.c"
}

void
usage_value_set_cpu_monitor (GValue* value,
                             gpointer v_object)
{
	UsageCpuMonitor * old;
#line 21 "../src/cpu-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_CPU_MONITOR));
#line 21 "../src/cpu-monitor.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/cpu-monitor.vala"
	if (v_object) {
#line 21 "../src/cpu-monitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, USAGE_TYPE_CPU_MONITOR));
#line 21 "../src/cpu-monitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../src/cpu-monitor.vala"
		usage_cpu_monitor_ref (value->data[0].v_pointer);
#line 783 "cpu-monitor.c"
	} else {
#line 21 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = NULL;
#line 787 "cpu-monitor.c"
	}
#line 21 "../src/cpu-monitor.vala"
	if (old) {
#line 21 "../src/cpu-monitor.vala"
		usage_cpu_monitor_unref (old);
#line 793 "cpu-monitor.c"
	}
}

void
usage_value_take_cpu_monitor (GValue* value,
                              gpointer v_object)
{
	UsageCpuMonitor * old;
#line 21 "../src/cpu-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_CPU_MONITOR));
#line 21 "../src/cpu-monitor.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/cpu-monitor.vala"
	if (v_object) {
#line 21 "../src/cpu-monitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, USAGE_TYPE_CPU_MONITOR));
#line 21 "../src/cpu-monitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = v_object;
#line 814 "cpu-monitor.c"
	} else {
#line 21 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = NULL;
#line 818 "cpu-monitor.c"
	}
#line 21 "../src/cpu-monitor.vala"
	if (old) {
#line 21 "../src/cpu-monitor.vala"
		usage_cpu_monitor_unref (old);
#line 824 "cpu-monitor.c"
	}
}

static void
usage_cpu_monitor_class_init (UsageCpuMonitorClass * klass,
                              gpointer klass_data)
{
#line 21 "../src/cpu-monitor.vala"
	usage_cpu_monitor_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/cpu-monitor.vala"
	((UsageCpuMonitorClass *) klass)->finalize = usage_cpu_monitor_finalize;
#line 21 "../src/cpu-monitor.vala"
	g_type_class_adjust_private_offset (klass, &UsageCpuMonitor_private_offset);
#line 838 "cpu-monitor.c"
}

static void
usage_cpu_monitor_usage_monitor_interface_init (UsageMonitorIface * iface,
                                                gpointer iface_data)
{
#line 21 "../src/cpu-monitor.vala"
	usage_cpu_monitor_usage_monitor_parent_iface = g_type_interface_peek_parent (iface);
#line 21 "../src/cpu-monitor.vala"
	iface->update = (void (*) (UsageMonitor*)) usage_cpu_monitor_real_update;
#line 21 "../src/cpu-monitor.vala"
	iface->update_process = (void (*) (UsageMonitor*, UsageProcess**)) usage_cpu_monitor_real_update_process;
#line 851 "cpu-monitor.c"
}

static void
usage_cpu_monitor_instance_init (UsageCpuMonitor * self,
                                 gpointer klass)
{
#line 21 "../src/cpu-monitor.vala"
	self->priv = usage_cpu_monitor_get_instance_private (self);
#line 24 "../src/cpu-monitor.vala"
	self->priv->cpu_last_used = (guint64) 0;
#line 25 "../src/cpu-monitor.vala"
	self->priv->cpu_last_total = (guint64) 0;
#line 26 "../src/cpu-monitor.vala"
	self->priv->cpu_last_total_step = (guint64) 0;
#line 21 "../src/cpu-monitor.vala"
	self->ref_count = 1;
#line 868 "cpu-monitor.c"
}

static void
usage_cpu_monitor_finalize (UsageCpuMonitor * obj)
{
	UsageCpuMonitor * self;
#line 21 "../src/cpu-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_CPU_MONITOR, UsageCpuMonitor);
#line 21 "../src/cpu-monitor.vala"
	g_signal_handlers_destroy (self);
#line 23 "../src/cpu-monitor.vala"
	self->priv->x_cpu_load = (g_free (self->priv->x_cpu_load), NULL);
#line 27 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = (g_free (self->priv->x_cpu_last_used), NULL);
#line 28 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = (g_free (self->priv->x_cpu_last_total), NULL);
#line 885 "cpu-monitor.c"
}

static GType
usage_cpu_monitor_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { usage_value_cpu_monitor_init, usage_value_cpu_monitor_free_value, usage_value_cpu_monitor_copy_value, usage_value_cpu_monitor_peek_pointer, "p", usage_value_cpu_monitor_collect_value, "p", usage_value_cpu_monitor_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UsageCpuMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_cpu_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageCpuMonitor), 0, (GInstanceInitFunc) usage_cpu_monitor_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	static const GInterfaceInfo usage_monitor_info = { (GInterfaceInitFunc) usage_cpu_monitor_usage_monitor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType usage_cpu_monitor_type_id;
	usage_cpu_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UsageCpuMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
	g_type_add_interface_static (usage_cpu_monitor_type_id, USAGE_TYPE_MONITOR, &usage_monitor_info);
	UsageCpuMonitor_private_offset = g_type_add_instance_private (usage_cpu_monitor_type_id, sizeof (UsageCpuMonitorPrivate));
	return usage_cpu_monitor_type_id;
}

GType
usage_cpu_monitor_get_type (void)
{
	static volatile gsize usage_cpu_monitor_type_id__once = 0;
	if (g_once_init_enter (&usage_cpu_monitor_type_id__once)) {
		GType usage_cpu_monitor_type_id;
		usage_cpu_monitor_type_id = usage_cpu_monitor_get_type_once ();
		g_once_init_leave (&usage_cpu_monitor_type_id__once, usage_cpu_monitor_type_id);
	}
	return usage_cpu_monitor_type_id__once;
}

gpointer
usage_cpu_monitor_ref (gpointer instance)
{
	UsageCpuMonitor * self;
	self = instance;
#line 21 "../src/cpu-monitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../src/cpu-monitor.vala"
	return instance;
#line 923 "cpu-monitor.c"
}

void
usage_cpu_monitor_unref (gpointer instance)
{
	UsageCpuMonitor * self;
	self = instance;
#line 21 "../src/cpu-monitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../src/cpu-monitor.vala"
		USAGE_CPU_MONITOR_GET_CLASS (self)->finalize (self);
#line 21 "../src/cpu-monitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 937 "cpu-monitor.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

