/* vnstat.c generated by valac 0.56.18, the Vala compiler
 * generated from vnstat.vala, do not modify */

/* network-view.vala
 *
 * Copyright (C) 2023–2025 Markus Göllnitz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Markus Göllnitz <camelcasenick@bewares.it>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	VNSTAT_MODE_HOURLY = 'h',
	VNSTAT_MODE_DAILY = 'd',
	VNSTAT_MODE_MONTHLY = 'm',
	VNSTAT_MODE_TOP = 't'
} VnstatMode;

#define VNSTAT_TYPE_MODE (vnstat_mode_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define VNSTAT_TYPE_INTERFACE (vnstat_interface_get_type ())
#define VNSTAT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VNSTAT_TYPE_INTERFACE, VnstatInterface))
#define VNSTAT_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VNSTAT_TYPE_INTERFACE, VnstatInterfaceClass))
#define VNSTAT_IS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VNSTAT_TYPE_INTERFACE))
#define VNSTAT_IS_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VNSTAT_TYPE_INTERFACE))
#define VNSTAT_INTERFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VNSTAT_TYPE_INTERFACE, VnstatInterfaceClass))

typedef struct _VnstatInterface VnstatInterface;
typedef struct _VnstatInterfaceClass VnstatInterfaceClass;

#define VNSTAT_TYPE_TRAFFIC_DATA_POINT (vnstat_traffic_data_point_get_type ())
typedef struct _VnstatTrafficDataPoint VnstatTrafficDataPoint;
typedef struct _VnstatInterfacePrivate VnstatInterfacePrivate;
typedef struct _Block5Data Block5Data;
#define _vnstat_interface_unref0(var) ((var == NULL) ? NULL : (var = (vnstat_interface_unref (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
typedef struct _VnstatParamSpecInterface VnstatParamSpecInterface;

struct _VnstatTrafficDataPoint {
	gint64 timestamp;
	gdouble download;
	gdouble upload;
};

struct _VnstatInterface {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VnstatInterfacePrivate * priv;
};

struct _VnstatInterfaceClass {
	GTypeClass parent_class;
	void (*finalize) (VnstatInterface *self);
};

struct _VnstatInterfacePrivate {
	gchar* _name;
	gboolean _recently_used;
};

struct _Block5Data {
	int _ref_count_;
	VnstatInterface* self;
	GList* traffic;
};

struct _VnstatParamSpecInterface {
	GParamSpec parent_instance;
};

static gint VnstatInterface_private_offset;
static gpointer vnstat_interface_parent_class = NULL;

VALA_EXTERN GType vnstat_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean vnstat_test_exists (void);
static void _vala_JsonNode_free (JsonNode* self);
VALA_EXTERN gpointer vnstat_interface_ref (gpointer instance);
VALA_EXTERN void vnstat_interface_unref (gpointer instance);
VALA_EXTERN GParamSpec* vnstat_param_spec_interface (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void vnstat_value_set_interface (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void vnstat_value_take_interface (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer vnstat_value_get_interface (const GValue* value);
VALA_EXTERN GType vnstat_interface_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VnstatInterface, vnstat_interface_unref)
VALA_EXTERN VnstatInterface** vnstat_list_interfaces (gint* result_length1);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
VALA_EXTERN VnstatInterface* vnstat_interface_new (const gchar* name);
VALA_EXTERN VnstatInterface* vnstat_interface_construct (GType object_type,
                                             const gchar* name);
static void _vala_array_add2 (VnstatInterface** * array,
                       gint* length,
                       gint* size,
                       VnstatInterface* value);
VALA_EXTERN GType vnstat_traffic_data_point_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VnstatTrafficDataPoint* vnstat_traffic_data_point_dup (const VnstatTrafficDataPoint* self);
VALA_EXTERN void vnstat_traffic_data_point_free (VnstatTrafficDataPoint* self);
static void vnstat_interface_set_name (VnstatInterface* self,
                                const gchar* value);
VALA_EXTERN GList* vnstat_interface_get_traffic (VnstatInterface* self,
                                     VnstatMode mode);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void _vnstat_traffic_data_point_free0_ (gpointer var);
static inline void _g_list_free__vnstat_traffic_data_point_free0_ (GList* self);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN const gchar* vnstat_interface_get_name (VnstatInterface* self);
static void ________lambda30_ (Block5Data* _data5_,
                        JsonArray* data_point_array,
                        guint data_point_index,
                        JsonNode* data_point_element);
static void _________lambda30__json_array_foreach (JsonArray* array,
                                            guint index_,
                                            JsonNode* element_node,
                                            gpointer self);
static guint* _uint_dup (guint* self);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
static void vnstat_interface_set_recently_used (VnstatInterface* self,
                                         gboolean value);
VALA_EXTERN gboolean vnstat_interface_get_recently_used (VnstatInterface* self);
static void vnstat_interface_finalize (VnstatInterface * obj);
static GType vnstat_interface_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
vnstat_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{VNSTAT_MODE_HOURLY, "VNSTAT_MODE_HOURLY", "hourly"}, {VNSTAT_MODE_DAILY, "VNSTAT_MODE_DAILY", "daily"}, {VNSTAT_MODE_MONTHLY, "VNSTAT_MODE_MONTHLY", "monthly"}, {VNSTAT_MODE_TOP, "VNSTAT_MODE_TOP", "top"}, {0, NULL, NULL}};
	GType vnstat_mode_type_id;
	vnstat_mode_type_id = g_enum_register_static ("VnstatMode", values);
	return vnstat_mode_type_id;
}

GType
vnstat_mode_get_type (void)
{
	static volatile gsize vnstat_mode_type_id__once = 0;
	if (g_once_init_enter (&vnstat_mode_type_id__once)) {
		GType vnstat_mode_type_id;
		vnstat_mode_type_id = vnstat_mode_get_type_once ();
		g_once_init_leave (&vnstat_mode_type_id__once, vnstat_mode_type_id);
	}
	return vnstat_mode_type_id__once;
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 43 "../src/network/vnstat.vala"
	return self ? json_object_ref (self) : NULL;
#line 207 "vnstat.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 37 "../src/network/vnstat.vala"
	g_boxed_free (json_node_get_type (), self);
#line 215 "vnstat.c"
}

gboolean
vnstat_test_exists (void)
{
	gboolean exists = FALSE;
	gchar* vnstat_stdout = NULL;
	gchar* vnstat_stderr = NULL;
	gint vnstat_status = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 31 "../src/network/vnstat.vala"
	exists = FALSE;
#line 229 "vnstat.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		JsonNode* _tmp3_ = NULL;
		const gchar* _tmp4_;
		JsonNode* _tmp5_;
		JsonNode* _tmp6_ = NULL;
		JsonObject* _tmp7_ = NULL;
		JsonObject* vnstat_json = NULL;
		JsonObject* _tmp9_;
		JsonObject* _tmp10_ = NULL;
		JsonObject* _tmp11_;
		const gchar* _tmp12_ = NULL;
#line 38 "../src/network/vnstat.vala"
		g_spawn_command_line_sync ("vnstat --json", &_tmp0_, &_tmp1_, &_tmp2_, &_inner_error0_);
#line 38 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stdout);
#line 38 "../src/network/vnstat.vala"
		vnstat_stdout = _tmp0_;
#line 38 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stderr);
#line 38 "../src/network/vnstat.vala"
		vnstat_stderr = _tmp1_;
#line 38 "../src/network/vnstat.vala"
		vnstat_status = _tmp2_;
#line 38 "../src/network/vnstat.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 260 "vnstat.c"
				goto __catch0_g_spawn_error;
			}
#line 38 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == JSON_PARSER_ERROR) {
#line 265 "vnstat.c"
				goto __catch0_json_parser_error;
			}
			goto __catch0_g_error;
		}
#line 43 "../src/network/vnstat.vala"
		_tmp4_ = vnstat_stdout;
#line 43 "../src/network/vnstat.vala"
		_tmp5_ = json_from_string (_tmp4_, &_inner_error0_);
#line 43 "../src/network/vnstat.vala"
		_tmp3_ = _tmp5_;
#line 43 "../src/network/vnstat.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 280 "vnstat.c"
				goto __catch0_g_spawn_error;
			}
#line 43 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == JSON_PARSER_ERROR) {
#line 285 "vnstat.c"
				goto __catch0_json_parser_error;
			}
			goto __catch0_g_error;
		}
#line 43 "../src/network/vnstat.vala"
		_tmp6_ = _tmp3_;
#line 43 "../src/network/vnstat.vala"
		_tmp7_ = NULL;
#line 43 "../src/network/vnstat.vala"
		if (_tmp6_ != NULL) {
#line 296 "vnstat.c"
			JsonObject* _tmp8_;
#line 43 "../src/network/vnstat.vala"
			_tmp8_ = json_node_get_object (_tmp6_);
#line 43 "../src/network/vnstat.vala"
			_tmp7_ = _tmp8_;
#line 302 "vnstat.c"
		}
#line 43 "../src/network/vnstat.vala"
		_tmp9_ = _json_object_ref0 (_tmp7_);
#line 43 "../src/network/vnstat.vala"
		vnstat_json = _tmp9_;
#line 45 "../src/network/vnstat.vala"
		_tmp11_ = vnstat_json;
#line 45 "../src/network/vnstat.vala"
		_tmp10_ = _tmp11_;
#line 45 "../src/network/vnstat.vala"
		_tmp12_ = NULL;
#line 45 "../src/network/vnstat.vala"
		if (_tmp10_ != NULL) {
#line 316 "vnstat.c"
			const gchar* _tmp13_;
#line 45 "../src/network/vnstat.vala"
			_tmp13_ = json_object_get_string_member (_tmp10_, "jsonversion");
#line 45 "../src/network/vnstat.vala"
			_tmp12_ = _tmp13_;
#line 322 "vnstat.c"
		}
#line 45 "../src/network/vnstat.vala"
		exists = g_strcmp0 (_tmp12_, "2") == 0;
#line 37 "../src/network/vnstat.vala"
		_json_object_unref0 (vnstat_json);
#line 37 "../src/network/vnstat.vala"
		__vala_JsonNode_free0 (_tmp3_);
#line 330 "vnstat.c"
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* _error_ = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 37 "../src/network/vnstat.vala"
		_error_ = _inner_error0_;
#line 37 "../src/network/vnstat.vala"
		_inner_error0_ = NULL;
#line 47 "../src/network/vnstat.vala"
		_tmp14_ = _error_;
#line 47 "../src/network/vnstat.vala"
		_tmp15_ = _tmp14_->message;
#line 47 "../src/network/vnstat.vala"
		g_info ("vnstat.vala:47: Error connecting to vnstat: %s\n", _tmp15_);
#line 37 "../src/network/vnstat.vala"
		_g_error_free0 (_error_);
#line 350 "vnstat.c"
	}
	goto __finally0;
	__catch0_json_parser_error:
	{
		GError* _error_ = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 37 "../src/network/vnstat.vala"
		_error_ = _inner_error0_;
#line 37 "../src/network/vnstat.vala"
		_inner_error0_ = NULL;
#line 49 "../src/network/vnstat.vala"
		_tmp16_ = _error_;
#line 49 "../src/network/vnstat.vala"
		_tmp17_ = _tmp16_->message;
#line 49 "../src/network/vnstat.vala"
		g_info ("vnstat.vala:49: Error parsing vnstat's result: %s\n", _tmp17_);
#line 37 "../src/network/vnstat.vala"
		_g_error_free0 (_error_);
#line 370 "vnstat.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 37 "../src/network/vnstat.vala"
		_error_ = _inner_error0_;
#line 37 "../src/network/vnstat.vala"
		_inner_error0_ = NULL;
#line 51 "../src/network/vnstat.vala"
		_tmp18_ = _error_;
#line 51 "../src/network/vnstat.vala"
		_tmp19_ = _tmp18_->message;
#line 51 "../src/network/vnstat.vala"
		g_info ("vnstat.vala:51: Error with vnstat: %s\n", _tmp19_);
#line 37 "../src/network/vnstat.vala"
		_g_error_free0 (_error_);
#line 390 "vnstat.c"
	}
	__finally0:
#line 37 "../src/network/vnstat.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 395 "vnstat.c"
		gboolean _tmp20_ = FALSE;
#line 37 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stderr);
#line 37 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stdout);
#line 37 "../src/network/vnstat.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "../src/network/vnstat.vala"
		g_clear_error (&_inner_error0_);
#line 37 "../src/network/vnstat.vala"
		return _tmp20_;
#line 407 "vnstat.c"
	}
#line 54 "../src/network/vnstat.vala"
	result = exists;
#line 54 "../src/network/vnstat.vala"
	_g_free0 (vnstat_stderr);
#line 54 "../src/network/vnstat.vala"
	_g_free0 (vnstat_stdout);
#line 54 "../src/network/vnstat.vala"
	return result;
#line 417 "vnstat.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 74 "../src/network/vnstat.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 425 "vnstat.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 74 "../src/network/vnstat.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 433 "vnstat.c"
}

static void
_vala_array_add2 (VnstatInterface** * array,
                  gint* length,
                  gint* size,
                  VnstatInterface* value)
{
#line 77 "../src/network/vnstat.vala"
	if ((*length) == (*size)) {
#line 77 "../src/network/vnstat.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 77 "../src/network/vnstat.vala"
		*array = g_renew (VnstatInterface*, *array, (*size) + 1);
#line 448 "vnstat.c"
	}
#line 77 "../src/network/vnstat.vala"
	(*array)[(*length)++] = value;
#line 77 "../src/network/vnstat.vala"
	(*array)[*length] = NULL;
#line 454 "vnstat.c"
}

VnstatInterface**
vnstat_list_interfaces (gint* result_length1)
{
	VnstatInterface** interfaces = NULL;
	VnstatInterface** _tmp0_;
	gint interfaces_length1;
	gint _interfaces_size_;
	gchar* vnstat_stdout = NULL;
	gchar* vnstat_stderr = NULL;
	gint vnstat_status = 0;
	VnstatInterface** _tmp36_;
	gint _tmp36__length1;
	GError* _inner_error0_ = NULL;
	VnstatInterface** result;
#line 58 "../src/network/vnstat.vala"
	_tmp0_ = g_new0 (VnstatInterface*, 0 + 1);
#line 58 "../src/network/vnstat.vala"
	interfaces = _tmp0_;
#line 58 "../src/network/vnstat.vala"
	interfaces_length1 = 0;
#line 58 "../src/network/vnstat.vala"
	_interfaces_size_ = interfaces_length1;
#line 479 "vnstat.c"
	{
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		JsonNode* _tmp4_ = NULL;
		const gchar* _tmp5_;
		JsonNode* _tmp6_;
		JsonNode* _tmp7_ = NULL;
		JsonObject* _tmp8_ = NULL;
		JsonObject* vnstat_json = NULL;
		JsonObject* _tmp10_;
		JsonObject* _tmp11_ = NULL;
		JsonObject* _tmp12_;
		JsonArray* _tmp13_ = NULL;
		JsonArray* _tmp15_ = NULL;
		GList* _tmp16_ = NULL;
		GList* interface_list = NULL;
		GList* _tmp18_;
		GList* _tmp19_;
#line 65 "../src/network/vnstat.vala"
		g_spawn_command_line_sync ("vnstat --json", &_tmp1_, &_tmp2_, &_tmp3_, &_inner_error0_);
#line 65 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stdout);
#line 65 "../src/network/vnstat.vala"
		vnstat_stdout = _tmp1_;
#line 65 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stderr);
#line 65 "../src/network/vnstat.vala"
		vnstat_stderr = _tmp2_;
#line 65 "../src/network/vnstat.vala"
		vnstat_status = _tmp3_;
#line 65 "../src/network/vnstat.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 515 "vnstat.c"
				goto __catch0_g_spawn_error;
			}
#line 65 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == JSON_PARSER_ERROR) {
#line 520 "vnstat.c"
				goto __catch0_json_parser_error;
			}
			goto __catch0_g_error;
		}
#line 70 "../src/network/vnstat.vala"
		_tmp5_ = vnstat_stdout;
#line 70 "../src/network/vnstat.vala"
		_tmp6_ = json_from_string (_tmp5_, &_inner_error0_);
#line 70 "../src/network/vnstat.vala"
		_tmp4_ = _tmp6_;
#line 70 "../src/network/vnstat.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 535 "vnstat.c"
				goto __catch0_g_spawn_error;
			}
#line 70 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == JSON_PARSER_ERROR) {
#line 540 "vnstat.c"
				goto __catch0_json_parser_error;
			}
			goto __catch0_g_error;
		}
#line 70 "../src/network/vnstat.vala"
		_tmp7_ = _tmp4_;
#line 70 "../src/network/vnstat.vala"
		_tmp8_ = NULL;
#line 70 "../src/network/vnstat.vala"
		if (_tmp7_ != NULL) {
#line 551 "vnstat.c"
			JsonObject* _tmp9_;
#line 70 "../src/network/vnstat.vala"
			_tmp9_ = json_node_get_object (_tmp7_);
#line 70 "../src/network/vnstat.vala"
			_tmp8_ = _tmp9_;
#line 557 "vnstat.c"
		}
#line 70 "../src/network/vnstat.vala"
		_tmp10_ = _json_object_ref0 (_tmp8_);
#line 70 "../src/network/vnstat.vala"
		vnstat_json = _tmp10_;
#line 72 "../src/network/vnstat.vala"
		_tmp12_ = vnstat_json;
#line 72 "../src/network/vnstat.vala"
		_tmp11_ = _tmp12_;
#line 72 "../src/network/vnstat.vala"
		_tmp13_ = NULL;
#line 72 "../src/network/vnstat.vala"
		if (_tmp11_ != NULL) {
#line 571 "vnstat.c"
			JsonArray* _tmp14_;
#line 72 "../src/network/vnstat.vala"
			_tmp14_ = json_object_get_array_member (_tmp11_, "interfaces");
#line 72 "../src/network/vnstat.vala"
			_tmp13_ = _tmp14_;
#line 577 "vnstat.c"
		}
#line 72 "../src/network/vnstat.vala"
		_tmp15_ = _tmp13_;
#line 72 "../src/network/vnstat.vala"
		_tmp16_ = NULL;
#line 72 "../src/network/vnstat.vala"
		if (_tmp15_ != NULL) {
#line 585 "vnstat.c"
			GList* _tmp17_;
#line 72 "../src/network/vnstat.vala"
			_tmp17_ = json_array_get_elements (_tmp15_);
#line 72 "../src/network/vnstat.vala"
			(_tmp16_ == NULL) ? NULL : (_tmp16_ = (g_list_free (_tmp16_), NULL));
#line 72 "../src/network/vnstat.vala"
			_tmp16_ = _tmp17_;
#line 593 "vnstat.c"
		}
#line 72 "../src/network/vnstat.vala"
		_tmp18_ = _tmp16_;
#line 72 "../src/network/vnstat.vala"
		_tmp16_ = NULL;
#line 72 "../src/network/vnstat.vala"
		interface_list = _tmp18_;
#line 73 "../src/network/vnstat.vala"
		_tmp19_ = interface_list;
#line 73 "../src/network/vnstat.vala"
		if (_tmp19_ != NULL) {
#line 605 "vnstat.c"
			GList* _tmp20_;
#line 74 "../src/network/vnstat.vala"
			_tmp20_ = interface_list;
#line 609 "vnstat.c"
			{
				GList* interface_element_collection = NULL;
				GList* interface_element_it = NULL;
#line 74 "../src/network/vnstat.vala"
				interface_element_collection = (GList*) _tmp20_;
#line 74 "../src/network/vnstat.vala"
				for (interface_element_it = interface_element_collection; interface_element_it != NULL; interface_element_it = interface_element_it->next) {
#line 617 "vnstat.c"
					JsonNode* _tmp21_;
					JsonNode* interface_element = NULL;
#line 74 "../src/network/vnstat.vala"
					_tmp21_ = __vala_JsonNode_copy0 ((JsonNode*) interface_element_it->data);
#line 74 "../src/network/vnstat.vala"
					interface_element = _tmp21_;
#line 624 "vnstat.c"
					{
						JsonObject* interface_json = NULL;
						JsonNode* _tmp22_;
						JsonObject* _tmp23_;
						JsonObject* _tmp24_;
						gchar* interface_name = NULL;
						JsonObject* _tmp25_;
						const gchar* _tmp26_;
						gchar* _tmp27_;
						const gchar* _tmp28_;
						VnstatInterface* _tmp29_;
#line 75 "../src/network/vnstat.vala"
						_tmp22_ = interface_element;
#line 75 "../src/network/vnstat.vala"
						_tmp23_ = json_node_get_object (_tmp22_);
#line 75 "../src/network/vnstat.vala"
						_tmp24_ = _json_object_ref0 ((JsonObject*) _tmp23_);
#line 75 "../src/network/vnstat.vala"
						interface_json = _tmp24_;
#line 76 "../src/network/vnstat.vala"
						_tmp25_ = interface_json;
#line 76 "../src/network/vnstat.vala"
						_tmp26_ = json_object_get_string_member_with_default (_tmp25_, "name", "");
#line 76 "../src/network/vnstat.vala"
						_tmp27_ = g_strdup (_tmp26_);
#line 76 "../src/network/vnstat.vala"
						interface_name = _tmp27_;
#line 77 "../src/network/vnstat.vala"
						_tmp28_ = interface_name;
#line 77 "../src/network/vnstat.vala"
						_tmp29_ = vnstat_interface_new (_tmp28_);
#line 77 "../src/network/vnstat.vala"
						_vala_array_add2 (&interfaces, &interfaces_length1, &_interfaces_size_, _tmp29_);
#line 74 "../src/network/vnstat.vala"
						_g_free0 (interface_name);
#line 74 "../src/network/vnstat.vala"
						_json_object_unref0 (interface_json);
#line 74 "../src/network/vnstat.vala"
						__vala_JsonNode_free0 (interface_element);
#line 664 "vnstat.c"
					}
				}
			}
		}
#line 64 "../src/network/vnstat.vala"
		(interface_list == NULL) ? NULL : (interface_list = (g_list_free (interface_list), NULL));
#line 64 "../src/network/vnstat.vala"
		(_tmp16_ == NULL) ? NULL : (_tmp16_ = (g_list_free (_tmp16_), NULL));
#line 64 "../src/network/vnstat.vala"
		_json_object_unref0 (vnstat_json);
#line 64 "../src/network/vnstat.vala"
		__vala_JsonNode_free0 (_tmp4_);
#line 677 "vnstat.c"
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* _error_ = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 64 "../src/network/vnstat.vala"
		_error_ = _inner_error0_;
#line 64 "../src/network/vnstat.vala"
		_inner_error0_ = NULL;
#line 81 "../src/network/vnstat.vala"
		_tmp30_ = _error_;
#line 81 "../src/network/vnstat.vala"
		_tmp31_ = _tmp30_->message;
#line 81 "../src/network/vnstat.vala"
		g_info ("vnstat.vala:81: Error connecting to vnstat: %s\n", _tmp31_);
#line 64 "../src/network/vnstat.vala"
		_g_error_free0 (_error_);
#line 697 "vnstat.c"
	}
	goto __finally0;
	__catch0_json_parser_error:
	{
		GError* _error_ = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
#line 64 "../src/network/vnstat.vala"
		_error_ = _inner_error0_;
#line 64 "../src/network/vnstat.vala"
		_inner_error0_ = NULL;
#line 83 "../src/network/vnstat.vala"
		_tmp32_ = _error_;
#line 83 "../src/network/vnstat.vala"
		_tmp33_ = _tmp32_->message;
#line 83 "../src/network/vnstat.vala"
		g_info ("vnstat.vala:83: Error parsing vnstat's result: %s\n", _tmp33_);
#line 64 "../src/network/vnstat.vala"
		_g_error_free0 (_error_);
#line 717 "vnstat.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp34_;
		const gchar* _tmp35_;
#line 64 "../src/network/vnstat.vala"
		_error_ = _inner_error0_;
#line 64 "../src/network/vnstat.vala"
		_inner_error0_ = NULL;
#line 85 "../src/network/vnstat.vala"
		_tmp34_ = _error_;
#line 85 "../src/network/vnstat.vala"
		_tmp35_ = _tmp34_->message;
#line 85 "../src/network/vnstat.vala"
		g_info ("vnstat.vala:85: Error with vnstat: %s\n", _tmp35_);
#line 64 "../src/network/vnstat.vala"
		_g_error_free0 (_error_);
#line 737 "vnstat.c"
	}
	__finally0:
#line 64 "../src/network/vnstat.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stderr);
#line 64 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stdout);
#line 64 "../src/network/vnstat.vala"
		interfaces = (_vala_array_free (interfaces, interfaces_length1, (GDestroyNotify) vnstat_interface_unref), NULL);
#line 64 "../src/network/vnstat.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/network/vnstat.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/network/vnstat.vala"
		return NULL;
#line 754 "vnstat.c"
	}
#line 88 "../src/network/vnstat.vala"
	_tmp36_ = interfaces;
#line 88 "../src/network/vnstat.vala"
	_tmp36__length1 = interfaces_length1;
#line 88 "../src/network/vnstat.vala"
	if (result_length1) {
#line 88 "../src/network/vnstat.vala"
		*result_length1 = _tmp36__length1;
#line 764 "vnstat.c"
	}
#line 88 "../src/network/vnstat.vala"
	result = _tmp36_;
#line 88 "../src/network/vnstat.vala"
	_g_free0 (vnstat_stderr);
#line 88 "../src/network/vnstat.vala"
	_g_free0 (vnstat_stdout);
#line 88 "../src/network/vnstat.vala"
	return result;
#line 774 "vnstat.c"
}

VnstatTrafficDataPoint*
vnstat_traffic_data_point_dup (const VnstatTrafficDataPoint* self)
{
	VnstatTrafficDataPoint* dup;
#line 91 "../src/network/vnstat.vala"
	dup = g_new0 (VnstatTrafficDataPoint, 1);
#line 91 "../src/network/vnstat.vala"
	memcpy (dup, self, sizeof (VnstatTrafficDataPoint));
#line 91 "../src/network/vnstat.vala"
	return dup;
#line 787 "vnstat.c"
}

void
vnstat_traffic_data_point_free (VnstatTrafficDataPoint* self)
{
#line 91 "../src/network/vnstat.vala"
	g_free (self);
#line 795 "vnstat.c"
}

static GType
vnstat_traffic_data_point_get_type_once (void)
{
	GType vnstat_traffic_data_point_type_id;
	vnstat_traffic_data_point_type_id = g_boxed_type_register_static ("VnstatTrafficDataPoint", (GBoxedCopyFunc) vnstat_traffic_data_point_dup, (GBoxedFreeFunc) vnstat_traffic_data_point_free);
	return vnstat_traffic_data_point_type_id;
}

GType
vnstat_traffic_data_point_get_type (void)
{
	static volatile gsize vnstat_traffic_data_point_type_id__once = 0;
	if (g_once_init_enter (&vnstat_traffic_data_point_type_id__once)) {
		GType vnstat_traffic_data_point_type_id;
		vnstat_traffic_data_point_type_id = vnstat_traffic_data_point_get_type_once ();
		g_once_init_leave (&vnstat_traffic_data_point_type_id__once, vnstat_traffic_data_point_type_id);
	}
	return vnstat_traffic_data_point_type_id__once;
}

static inline gpointer
vnstat_interface_get_instance_private (VnstatInterface* self)
{
	return G_STRUCT_MEMBER_P (self, VnstatInterface_private_offset);
}

VnstatInterface*
vnstat_interface_construct (GType object_type,
                            const gchar* name)
{
	VnstatInterface* self = NULL;
#line 101 "../src/network/vnstat.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 101 "../src/network/vnstat.vala"
	self = (VnstatInterface*) g_type_create_instance (object_type);
#line 102 "../src/network/vnstat.vala"
	vnstat_interface_set_name (self, name);
#line 101 "../src/network/vnstat.vala"
	return self;
#line 837 "vnstat.c"
}

VnstatInterface*
vnstat_interface_new (const gchar* name)
{
#line 101 "../src/network/vnstat.vala"
	return vnstat_interface_construct (VNSTAT_TYPE_INTERFACE, name);
#line 845 "vnstat.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 105 "../src/network/vnstat.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 105 "../src/network/vnstat.vala"
	return _data5_;
#line 855 "vnstat.c"
}

static void
_vnstat_traffic_data_point_free0_ (gpointer var)
{
#line 105 "../src/network/vnstat.vala"
	(var == NULL) ? NULL : (var = (vnstat_traffic_data_point_free (var), NULL));
#line 863 "vnstat.c"
}

static inline void
_g_list_free__vnstat_traffic_data_point_free0_ (GList* self)
{
#line 105 "../src/network/vnstat.vala"
	g_list_free_full (self, (GDestroyNotify) _vnstat_traffic_data_point_free0_);
#line 871 "vnstat.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 105 "../src/network/vnstat.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 881 "vnstat.c"
		VnstatInterface* self;
#line 105 "../src/network/vnstat.vala"
		self = _data5_->self;
#line 105 "../src/network/vnstat.vala"
		(_data5_->traffic == NULL) ? NULL : (_data5_->traffic = (_g_list_free__vnstat_traffic_data_point_free0_ (_data5_->traffic), NULL));
#line 105 "../src/network/vnstat.vala"
		_vnstat_interface_unref0 (self);
#line 105 "../src/network/vnstat.vala"
		g_slice_free (Block5Data, _data5_);
#line 891 "vnstat.c"
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 905 "vnstat.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 142 "../src/network/vnstat.vala"
	return self ? json_array_ref (self) : NULL;
#line 913 "vnstat.c"
}

static gpointer
_vnstat_traffic_data_point_dup0 (gpointer self)
{
#line 147 "../src/network/vnstat.vala"
	return self ? vnstat_traffic_data_point_dup (self) : NULL;
#line 921 "vnstat.c"
}

static void
________lambda30_ (Block5Data* _data5_,
                   JsonArray* data_point_array,
                   guint data_point_index,
                   JsonNode* data_point_element)
{
	VnstatInterface* self;
	JsonObject* data_point_json = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	VnstatTrafficDataPoint _tmp2_ = {0};
	VnstatTrafficDataPoint* _tmp3_;
#line 144 "../src/network/vnstat.vala"
	self = _data5_->self;
#line 144 "../src/network/vnstat.vala"
	g_return_if_fail (data_point_array != NULL);
#line 144 "../src/network/vnstat.vala"
	g_return_if_fail (data_point_element != NULL);
#line 145 "../src/network/vnstat.vala"
	_tmp0_ = json_node_get_object (data_point_element);
#line 145 "../src/network/vnstat.vala"
	_tmp1_ = _json_object_ref0 ((JsonObject*) _tmp0_);
#line 145 "../src/network/vnstat.vala"
	data_point_json = _tmp1_;
#line 147 "../src/network/vnstat.vala"
	memset (&_tmp2_, 0, sizeof (VnstatTrafficDataPoint));
#line 147 "../src/network/vnstat.vala"
	_tmp2_.timestamp = json_object_get_int_member (data_point_json, "timestamp");
#line 147 "../src/network/vnstat.vala"
	_tmp2_.download = (gdouble) json_object_get_int_member (data_point_json, "rx");
#line 147 "../src/network/vnstat.vala"
	_tmp2_.upload = (gdouble) json_object_get_int_member (data_point_json, "tx");
#line 147 "../src/network/vnstat.vala"
	_tmp3_ = _vnstat_traffic_data_point_dup0 (&_tmp2_);
#line 147 "../src/network/vnstat.vala"
	_data5_->traffic = g_list_append (_data5_->traffic, _tmp3_);
#line 144 "../src/network/vnstat.vala"
	_json_object_unref0 (data_point_json);
#line 962 "vnstat.c"
}

static void
_________lambda30__json_array_foreach (JsonArray* array,
                                       guint index_,
                                       JsonNode* element_node,
                                       gpointer self)
{
#line 144 "../src/network/vnstat.vala"
	________lambda30_ (self, array, index_, element_node);
#line 973 "vnstat.c"
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 154 "../src/network/vnstat.vala"
	dup = g_new0 (guint, 1);
#line 154 "../src/network/vnstat.vala"
	memcpy (dup, self, sizeof (guint));
#line 154 "../src/network/vnstat.vala"
	return dup;
#line 986 "vnstat.c"
}

static gpointer
__uint_dup0 (gpointer self)
{
#line 154 "../src/network/vnstat.vala"
	return self ? _uint_dup (self) : NULL;
#line 994 "vnstat.c"
}

static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
#line 154 "../src/network/vnstat.vala"
	if (s1 == s2) {
#line 154 "../src/network/vnstat.vala"
		return TRUE;
#line 1005 "vnstat.c"
	}
#line 154 "../src/network/vnstat.vala"
	if (s1 == NULL) {
#line 154 "../src/network/vnstat.vala"
		return FALSE;
#line 1011 "vnstat.c"
	}
#line 154 "../src/network/vnstat.vala"
	if (s2 == NULL) {
#line 154 "../src/network/vnstat.vala"
		return FALSE;
#line 1017 "vnstat.c"
	}
#line 154 "../src/network/vnstat.vala"
	return (*s1) == (*s2);
#line 1021 "vnstat.c"
}

GList*
vnstat_interface_get_traffic (VnstatInterface* self,
                              VnstatMode mode)
{
	Block5Data* _data5_;
	gchar* vnstat_stdout = NULL;
	gchar* vnstat_stderr = NULL;
	gint vnstat_status = 0;
	GList* _tmp57_;
	GError* _inner_error0_ = NULL;
	GList* result;
#line 105 "../src/network/vnstat.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../src/network/vnstat.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 105 "../src/network/vnstat.vala"
	_data5_->_ref_count_ = 1;
#line 105 "../src/network/vnstat.vala"
	_data5_->self = vnstat_interface_ref (self);
#line 106 "../src/network/vnstat.vala"
	_data5_->traffic = NULL;
#line 1045 "vnstat.c"
	{
		GEnumValue* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gint _tmp7_ = 0;
#line 113 "../src/network/vnstat.vala"
		_tmp0_ = g_enum_get_value (g_type_class_ref (VNSTAT_TYPE_MODE), mode);
#line 113 "../src/network/vnstat.vala"
		_tmp1_ = self->priv->_name;
#line 113 "../src/network/vnstat.vala"
		_tmp2_ = string_to_string (_tmp1_);
#line 113 "../src/network/vnstat.vala"
		_tmp3_ = g_strconcat ("vnstat --json ", (_tmp0_ != NULL) ? _tmp0_->value_name : NULL, " -i ", _tmp2_, NULL);
#line 113 "../src/network/vnstat.vala"
		_tmp4_ = _tmp3_;
#line 113 "../src/network/vnstat.vala"
		g_spawn_command_line_sync (_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_, &_inner_error0_);
#line 113 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stdout);
#line 113 "../src/network/vnstat.vala"
		vnstat_stdout = _tmp5_;
#line 113 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stderr);
#line 113 "../src/network/vnstat.vala"
		vnstat_stderr = _tmp6_;
#line 113 "../src/network/vnstat.vala"
		vnstat_status = _tmp7_;
#line 113 "../src/network/vnstat.vala"
		_g_free0 (_tmp4_);
#line 113 "../src/network/vnstat.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1083 "vnstat.c"
				goto __catch0_g_spawn_error;
			}
#line 113 "../src/network/vnstat.vala"
			if (_inner_error0_->domain == JSON_PARSER_ERROR) {
#line 1088 "vnstat.c"
				goto __catch0_json_parser_error;
			}
			goto __catch0_g_error;
		}
#line 118 "../src/network/vnstat.vala"
		if (vnstat_status == 0) {
#line 1095 "vnstat.c"
			JsonNode* _tmp8_ = NULL;
			const gchar* _tmp9_;
			JsonNode* _tmp10_;
			JsonNode* _tmp11_ = NULL;
			JsonObject* _tmp12_ = NULL;
			JsonObject* vnstat_json = NULL;
			JsonObject* _tmp14_;
			JsonObject* _tmp15_ = NULL;
			JsonObject* _tmp16_;
			JsonArray* _tmp17_ = NULL;
			JsonArray* _tmp19_ = NULL;
			GList* _tmp20_ = NULL;
			GList* interface_list = NULL;
			GList* _tmp22_;
			GList* _tmp23_;
#line 119 "../src/network/vnstat.vala"
			_tmp9_ = vnstat_stdout;
#line 119 "../src/network/vnstat.vala"
			_tmp10_ = json_from_string (_tmp9_, &_inner_error0_);
#line 119 "../src/network/vnstat.vala"
			_tmp8_ = _tmp10_;
#line 119 "../src/network/vnstat.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "../src/network/vnstat.vala"
				if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1121 "vnstat.c"
					goto __catch0_g_spawn_error;
				}
#line 119 "../src/network/vnstat.vala"
				if (_inner_error0_->domain == JSON_PARSER_ERROR) {
#line 1126 "vnstat.c"
					goto __catch0_json_parser_error;
				}
				goto __catch0_g_error;
			}
#line 119 "../src/network/vnstat.vala"
			_tmp11_ = _tmp8_;
#line 119 "../src/network/vnstat.vala"
			_tmp12_ = NULL;
#line 119 "../src/network/vnstat.vala"
			if (_tmp11_ != NULL) {
#line 1137 "vnstat.c"
				JsonObject* _tmp13_;
#line 119 "../src/network/vnstat.vala"
				_tmp13_ = json_node_get_object (_tmp11_);
#line 119 "../src/network/vnstat.vala"
				_tmp12_ = _tmp13_;
#line 1143 "vnstat.c"
			}
#line 119 "../src/network/vnstat.vala"
			_tmp14_ = _json_object_ref0 (_tmp12_);
#line 119 "../src/network/vnstat.vala"
			vnstat_json = _tmp14_;
#line 121 "../src/network/vnstat.vala"
			_tmp16_ = vnstat_json;
#line 121 "../src/network/vnstat.vala"
			_tmp15_ = _tmp16_;
#line 121 "../src/network/vnstat.vala"
			_tmp17_ = NULL;
#line 121 "../src/network/vnstat.vala"
			if (_tmp15_ != NULL) {
#line 1157 "vnstat.c"
				JsonArray* _tmp18_;
#line 121 "../src/network/vnstat.vala"
				_tmp18_ = json_object_get_array_member (_tmp15_, "interfaces");
#line 121 "../src/network/vnstat.vala"
				_tmp17_ = _tmp18_;
#line 1163 "vnstat.c"
			}
#line 121 "../src/network/vnstat.vala"
			_tmp19_ = _tmp17_;
#line 121 "../src/network/vnstat.vala"
			_tmp20_ = NULL;
#line 121 "../src/network/vnstat.vala"
			if (_tmp19_ != NULL) {
#line 1171 "vnstat.c"
				GList* _tmp21_;
#line 121 "../src/network/vnstat.vala"
				_tmp21_ = json_array_get_elements (_tmp19_);
#line 121 "../src/network/vnstat.vala"
				(_tmp20_ == NULL) ? NULL : (_tmp20_ = (g_list_free (_tmp20_), NULL));
#line 121 "../src/network/vnstat.vala"
				_tmp20_ = _tmp21_;
#line 1179 "vnstat.c"
			}
#line 121 "../src/network/vnstat.vala"
			_tmp22_ = _tmp20_;
#line 121 "../src/network/vnstat.vala"
			_tmp20_ = NULL;
#line 121 "../src/network/vnstat.vala"
			interface_list = _tmp22_;
#line 122 "../src/network/vnstat.vala"
			_tmp23_ = interface_list;
#line 122 "../src/network/vnstat.vala"
			if (_tmp23_ != NULL) {
#line 1191 "vnstat.c"
				GList* _tmp24_;
#line 123 "../src/network/vnstat.vala"
				_tmp24_ = interface_list;
#line 1195 "vnstat.c"
				{
					GList* interface_element_collection = NULL;
					GList* interface_element_it = NULL;
#line 123 "../src/network/vnstat.vala"
					interface_element_collection = (GList*) _tmp24_;
#line 123 "../src/network/vnstat.vala"
					for (interface_element_it = interface_element_collection; interface_element_it != NULL; interface_element_it = interface_element_it->next) {
#line 1203 "vnstat.c"
						JsonNode* _tmp25_;
						JsonNode* interface_element = NULL;
#line 123 "../src/network/vnstat.vala"
						_tmp25_ = __vala_JsonNode_copy0 ((JsonNode*) interface_element_it->data);
#line 123 "../src/network/vnstat.vala"
						interface_element = _tmp25_;
#line 1210 "vnstat.c"
						{
							JsonObject* interface_json = NULL;
							JsonNode* _tmp26_;
							JsonObject* _tmp27_;
							JsonObject* _tmp28_;
							gchar* member_name = NULL;
							gchar* _tmp29_;
							JsonObject* _tmp34_ = NULL;
							JsonObject* _tmp35_;
							JsonObject* _tmp36_ = NULL;
							JsonObject* _tmp38_ = NULL;
							JsonArray* _tmp39_ = NULL;
							JsonArray* traffic_json = NULL;
							JsonArray* _tmp42_;
							JsonArray* _tmp43_ = NULL;
							JsonArray* _tmp44_;
							JsonArray* _tmp45_ = NULL;
							JsonArray* _tmp46_;
							guint* _tmp47_ = NULL;
							guint _tmp50_;
#line 124 "../src/network/vnstat.vala"
							_tmp26_ = interface_element;
#line 124 "../src/network/vnstat.vala"
							_tmp27_ = json_node_get_object (_tmp26_);
#line 124 "../src/network/vnstat.vala"
							_tmp28_ = _json_object_ref0 (_tmp27_);
#line 124 "../src/network/vnstat.vala"
							interface_json = _tmp28_;
#line 125 "../src/network/vnstat.vala"
							_tmp29_ = g_strdup ("");
#line 125 "../src/network/vnstat.vala"
							member_name = _tmp29_;
#line 127 "../src/network/vnstat.vala"
							switch (mode) {
#line 127 "../src/network/vnstat.vala"
								case VNSTAT_MODE_HOURLY:
#line 1247 "vnstat.c"
								{
									gchar* _tmp30_;
#line 129 "../src/network/vnstat.vala"
									_tmp30_ = g_strdup ("hour");
#line 129 "../src/network/vnstat.vala"
									_g_free0 (member_name);
#line 129 "../src/network/vnstat.vala"
									member_name = _tmp30_;
#line 130 "../src/network/vnstat.vala"
									break;
#line 1258 "vnstat.c"
								}
#line 127 "../src/network/vnstat.vala"
								case VNSTAT_MODE_DAILY:
#line 1262 "vnstat.c"
								{
									gchar* _tmp31_;
#line 132 "../src/network/vnstat.vala"
									_tmp31_ = g_strdup ("day");
#line 132 "../src/network/vnstat.vala"
									_g_free0 (member_name);
#line 132 "../src/network/vnstat.vala"
									member_name = _tmp31_;
#line 133 "../src/network/vnstat.vala"
									break;
#line 1273 "vnstat.c"
								}
#line 127 "../src/network/vnstat.vala"
								case VNSTAT_MODE_MONTHLY:
#line 1277 "vnstat.c"
								{
									gchar* _tmp32_;
#line 135 "../src/network/vnstat.vala"
									_tmp32_ = g_strdup ("month");
#line 135 "../src/network/vnstat.vala"
									_g_free0 (member_name);
#line 135 "../src/network/vnstat.vala"
									member_name = _tmp32_;
#line 136 "../src/network/vnstat.vala"
									break;
#line 1288 "vnstat.c"
								}
#line 127 "../src/network/vnstat.vala"
								case VNSTAT_MODE_TOP:
#line 1292 "vnstat.c"
								{
									gchar* _tmp33_;
#line 138 "../src/network/vnstat.vala"
									_tmp33_ = g_strdup ("top");
#line 138 "../src/network/vnstat.vala"
									_g_free0 (member_name);
#line 138 "../src/network/vnstat.vala"
									member_name = _tmp33_;
#line 139 "../src/network/vnstat.vala"
									break;
#line 1303 "vnstat.c"
								}
								default:
#line 127 "../src/network/vnstat.vala"
								break;
#line 1308 "vnstat.c"
							}
#line 142 "../src/network/vnstat.vala"
							_tmp35_ = interface_json;
#line 142 "../src/network/vnstat.vala"
							_tmp34_ = _tmp35_;
#line 142 "../src/network/vnstat.vala"
							_tmp36_ = NULL;
#line 142 "../src/network/vnstat.vala"
							if (_tmp34_ != NULL) {
#line 1318 "vnstat.c"
								JsonObject* _tmp37_;
#line 142 "../src/network/vnstat.vala"
								_tmp37_ = json_object_get_object_member (_tmp34_, "traffic");
#line 142 "../src/network/vnstat.vala"
								_tmp36_ = _tmp37_;
#line 1324 "vnstat.c"
							}
#line 142 "../src/network/vnstat.vala"
							_tmp38_ = _tmp36_;
#line 142 "../src/network/vnstat.vala"
							_tmp39_ = NULL;
#line 142 "../src/network/vnstat.vala"
							if (_tmp38_ != NULL) {
#line 1332 "vnstat.c"
								const gchar* _tmp40_;
								JsonArray* _tmp41_;
#line 142 "../src/network/vnstat.vala"
								_tmp40_ = member_name;
#line 142 "../src/network/vnstat.vala"
								_tmp41_ = json_object_get_array_member (_tmp38_, _tmp40_);
#line 142 "../src/network/vnstat.vala"
								_tmp39_ = _tmp41_;
#line 1341 "vnstat.c"
							}
#line 142 "../src/network/vnstat.vala"
							_tmp42_ = _json_array_ref0 (_tmp39_);
#line 142 "../src/network/vnstat.vala"
							traffic_json = _tmp42_;
#line 144 "../src/network/vnstat.vala"
							_tmp44_ = traffic_json;
#line 144 "../src/network/vnstat.vala"
							_tmp43_ = _tmp44_;
#line 144 "../src/network/vnstat.vala"
							if (_tmp43_ != NULL) {
#line 144 "../src/network/vnstat.vala"
								json_array_foreach_element (_tmp43_, _________lambda30__json_array_foreach, _data5_);
#line 1355 "vnstat.c"
							}
#line 154 "../src/network/vnstat.vala"
							_tmp46_ = traffic_json;
#line 154 "../src/network/vnstat.vala"
							_tmp45_ = _tmp46_;
#line 154 "../src/network/vnstat.vala"
							_tmp47_ = NULL;
#line 154 "../src/network/vnstat.vala"
							if (_tmp45_ != NULL) {
#line 1365 "vnstat.c"
								guint _tmp48_;
								guint* _tmp49_;
#line 154 "../src/network/vnstat.vala"
								_tmp48_ = json_array_get_length (_tmp45_);
#line 154 "../src/network/vnstat.vala"
								_tmp49_ = __uint_dup0 (&_tmp48_);
#line 154 "../src/network/vnstat.vala"
								_g_free0 (_tmp47_);
#line 154 "../src/network/vnstat.vala"
								_tmp47_ = _tmp49_;
#line 1376 "vnstat.c"
							}
#line 154 "../src/network/vnstat.vala"
							_tmp50_ = (guint) 0;
#line 154 "../src/network/vnstat.vala"
							vnstat_interface_set_recently_used (self, _uint_equal (_tmp47_, &_tmp50_) != TRUE);
#line 123 "../src/network/vnstat.vala"
							_g_free0 (_tmp47_);
#line 123 "../src/network/vnstat.vala"
							_json_array_unref0 (traffic_json);
#line 123 "../src/network/vnstat.vala"
							_g_free0 (member_name);
#line 123 "../src/network/vnstat.vala"
							_json_object_unref0 (interface_json);
#line 123 "../src/network/vnstat.vala"
							__vala_JsonNode_free0 (interface_element);
#line 1392 "vnstat.c"
						}
					}
				}
			}
#line 118 "../src/network/vnstat.vala"
			(interface_list == NULL) ? NULL : (interface_list = (g_list_free (interface_list), NULL));
#line 118 "../src/network/vnstat.vala"
			(_tmp20_ == NULL) ? NULL : (_tmp20_ = (g_list_free (_tmp20_), NULL));
#line 118 "../src/network/vnstat.vala"
			_json_object_unref0 (vnstat_json);
#line 118 "../src/network/vnstat.vala"
			__vala_JsonNode_free0 (_tmp8_);
#line 1405 "vnstat.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* _error_ = NULL;
		GError* _tmp51_;
		const gchar* _tmp52_;
#line 112 "../src/network/vnstat.vala"
		_error_ = _inner_error0_;
#line 112 "../src/network/vnstat.vala"
		_inner_error0_ = NULL;
#line 159 "../src/network/vnstat.vala"
		_tmp51_ = _error_;
#line 159 "../src/network/vnstat.vala"
		_tmp52_ = _tmp51_->message;
#line 159 "../src/network/vnstat.vala"
		g_info ("vnstat.vala:159: Error connecting to vnstat: %s\n", _tmp52_);
#line 112 "../src/network/vnstat.vala"
		_g_error_free0 (_error_);
#line 1426 "vnstat.c"
	}
	goto __finally0;
	__catch0_json_parser_error:
	{
		GError* _error_ = NULL;
		GError* _tmp53_;
		const gchar* _tmp54_;
#line 112 "../src/network/vnstat.vala"
		_error_ = _inner_error0_;
#line 112 "../src/network/vnstat.vala"
		_inner_error0_ = NULL;
#line 161 "../src/network/vnstat.vala"
		_tmp53_ = _error_;
#line 161 "../src/network/vnstat.vala"
		_tmp54_ = _tmp53_->message;
#line 161 "../src/network/vnstat.vala"
		g_info ("vnstat.vala:161: Error parsing vnstat's result: %s\n", _tmp54_);
#line 112 "../src/network/vnstat.vala"
		_g_error_free0 (_error_);
#line 1446 "vnstat.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp55_;
		const gchar* _tmp56_;
#line 112 "../src/network/vnstat.vala"
		_error_ = _inner_error0_;
#line 112 "../src/network/vnstat.vala"
		_inner_error0_ = NULL;
#line 163 "../src/network/vnstat.vala"
		_tmp55_ = _error_;
#line 163 "../src/network/vnstat.vala"
		_tmp56_ = _tmp55_->message;
#line 163 "../src/network/vnstat.vala"
		g_info ("vnstat.vala:163: Error with vnstat: %s\n", _tmp56_);
#line 112 "../src/network/vnstat.vala"
		_g_error_free0 (_error_);
#line 1466 "vnstat.c"
	}
	__finally0:
#line 112 "../src/network/vnstat.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stderr);
#line 112 "../src/network/vnstat.vala"
		_g_free0 (vnstat_stdout);
#line 112 "../src/network/vnstat.vala"
		block5_data_unref (_data5_);
#line 112 "../src/network/vnstat.vala"
		_data5_ = NULL;
#line 112 "../src/network/vnstat.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 112 "../src/network/vnstat.vala"
		g_clear_error (&_inner_error0_);
#line 112 "../src/network/vnstat.vala"
		return NULL;
#line 1485 "vnstat.c"
	}
#line 166 "../src/network/vnstat.vala"
	_tmp57_ = _data5_->traffic;
#line 166 "../src/network/vnstat.vala"
	_data5_->traffic = NULL;
#line 166 "../src/network/vnstat.vala"
	result = _tmp57_;
#line 166 "../src/network/vnstat.vala"
	_g_free0 (vnstat_stderr);
#line 166 "../src/network/vnstat.vala"
	_g_free0 (vnstat_stdout);
#line 166 "../src/network/vnstat.vala"
	block5_data_unref (_data5_);
#line 166 "../src/network/vnstat.vala"
	_data5_ = NULL;
#line 166 "../src/network/vnstat.vala"
	return result;
#line 1503 "vnstat.c"
}

const gchar*
vnstat_interface_get_name (VnstatInterface* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 98 "../src/network/vnstat.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../src/network/vnstat.vala"
	_tmp0_ = self->priv->_name;
#line 98 "../src/network/vnstat.vala"
	result = _tmp0_;
#line 98 "../src/network/vnstat.vala"
	return result;
#line 1519 "vnstat.c"
}

static void
vnstat_interface_set_name (VnstatInterface* self,
                           const gchar* value)
{
	gchar* _tmp0_;
#line 98 "../src/network/vnstat.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/network/vnstat.vala"
	_tmp0_ = g_strdup (value);
#line 98 "../src/network/vnstat.vala"
	_g_free0 (self->priv->_name);
#line 98 "../src/network/vnstat.vala"
	self->priv->_name = _tmp0_;
#line 1535 "vnstat.c"
}

gboolean
vnstat_interface_get_recently_used (VnstatInterface* self)
{
	gboolean result;
#line 99 "../src/network/vnstat.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "../src/network/vnstat.vala"
	result = self->priv->_recently_used;
#line 99 "../src/network/vnstat.vala"
	return result;
#line 1548 "vnstat.c"
}

static void
vnstat_interface_set_recently_used (VnstatInterface* self,
                                    gboolean value)
{
#line 99 "../src/network/vnstat.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/network/vnstat.vala"
	self->priv->_recently_used = value;
#line 1559 "vnstat.c"
}

static void
vnstat_value_interface_init (GValue* value)
{
#line 97 "../src/network/vnstat.vala"
	value->data[0].v_pointer = NULL;
#line 1567 "vnstat.c"
}

static void
vnstat_value_interface_free_value (GValue* value)
{
#line 97 "../src/network/vnstat.vala"
	if (value->data[0].v_pointer) {
#line 97 "../src/network/vnstat.vala"
		vnstat_interface_unref (value->data[0].v_pointer);
#line 1577 "vnstat.c"
	}
}

static void
vnstat_value_interface_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 97 "../src/network/vnstat.vala"
	if (src_value->data[0].v_pointer) {
#line 97 "../src/network/vnstat.vala"
		dest_value->data[0].v_pointer = vnstat_interface_ref (src_value->data[0].v_pointer);
#line 1589 "vnstat.c"
	} else {
#line 97 "../src/network/vnstat.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1593 "vnstat.c"
	}
}

static gpointer
vnstat_value_interface_peek_pointer (const GValue* value)
{
#line 97 "../src/network/vnstat.vala"
	return value->data[0].v_pointer;
#line 1602 "vnstat.c"
}

static gchar*
vnstat_value_interface_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 97 "../src/network/vnstat.vala"
	if (collect_values[0].v_pointer) {
#line 1613 "vnstat.c"
		VnstatInterface * object;
		object = collect_values[0].v_pointer;
#line 97 "../src/network/vnstat.vala"
		if (object->parent_instance.g_class == NULL) {
#line 97 "../src/network/vnstat.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1620 "vnstat.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 97 "../src/network/vnstat.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1624 "vnstat.c"
		}
#line 97 "../src/network/vnstat.vala"
		value->data[0].v_pointer = vnstat_interface_ref (object);
#line 1628 "vnstat.c"
	} else {
#line 97 "../src/network/vnstat.vala"
		value->data[0].v_pointer = NULL;
#line 1632 "vnstat.c"
	}
#line 97 "../src/network/vnstat.vala"
	return NULL;
#line 1636 "vnstat.c"
}

static gchar*
vnstat_value_interface_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	VnstatInterface ** object_p;
	object_p = collect_values[0].v_pointer;
#line 97 "../src/network/vnstat.vala"
	if (!object_p) {
#line 97 "../src/network/vnstat.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1651 "vnstat.c"
	}
#line 97 "../src/network/vnstat.vala"
	if (!value->data[0].v_pointer) {
#line 97 "../src/network/vnstat.vala"
		*object_p = NULL;
#line 1657 "vnstat.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 97 "../src/network/vnstat.vala"
		*object_p = value->data[0].v_pointer;
#line 1661 "vnstat.c"
	} else {
#line 97 "../src/network/vnstat.vala"
		*object_p = vnstat_interface_ref (value->data[0].v_pointer);
#line 1665 "vnstat.c"
	}
#line 97 "../src/network/vnstat.vala"
	return NULL;
#line 1669 "vnstat.c"
}

GParamSpec*
vnstat_param_spec_interface (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	VnstatParamSpecInterface* spec;
#line 97 "../src/network/vnstat.vala"
	g_return_val_if_fail (g_type_is_a (object_type, VNSTAT_TYPE_INTERFACE), NULL);
#line 97 "../src/network/vnstat.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 97 "../src/network/vnstat.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 97 "../src/network/vnstat.vala"
	return G_PARAM_SPEC (spec);
#line 1688 "vnstat.c"
}

gpointer
vnstat_value_get_interface (const GValue* value)
{
#line 97 "../src/network/vnstat.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VNSTAT_TYPE_INTERFACE), NULL);
#line 97 "../src/network/vnstat.vala"
	return value->data[0].v_pointer;
#line 1698 "vnstat.c"
}

void
vnstat_value_set_interface (GValue* value,
                            gpointer v_object)
{
	VnstatInterface * old;
#line 97 "../src/network/vnstat.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VNSTAT_TYPE_INTERFACE));
#line 97 "../src/network/vnstat.vala"
	old = value->data[0].v_pointer;
#line 97 "../src/network/vnstat.vala"
	if (v_object) {
#line 97 "../src/network/vnstat.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VNSTAT_TYPE_INTERFACE));
#line 97 "../src/network/vnstat.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 97 "../src/network/vnstat.vala"
		value->data[0].v_pointer = v_object;
#line 97 "../src/network/vnstat.vala"
		vnstat_interface_ref (value->data[0].v_pointer);
#line 1720 "vnstat.c"
	} else {
#line 97 "../src/network/vnstat.vala"
		value->data[0].v_pointer = NULL;
#line 1724 "vnstat.c"
	}
#line 97 "../src/network/vnstat.vala"
	if (old) {
#line 97 "../src/network/vnstat.vala"
		vnstat_interface_unref (old);
#line 1730 "vnstat.c"
	}
}

void
vnstat_value_take_interface (GValue* value,
                             gpointer v_object)
{
	VnstatInterface * old;
#line 97 "../src/network/vnstat.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VNSTAT_TYPE_INTERFACE));
#line 97 "../src/network/vnstat.vala"
	old = value->data[0].v_pointer;
#line 97 "../src/network/vnstat.vala"
	if (v_object) {
#line 97 "../src/network/vnstat.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VNSTAT_TYPE_INTERFACE));
#line 97 "../src/network/vnstat.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 97 "../src/network/vnstat.vala"
		value->data[0].v_pointer = v_object;
#line 1751 "vnstat.c"
	} else {
#line 97 "../src/network/vnstat.vala"
		value->data[0].v_pointer = NULL;
#line 1755 "vnstat.c"
	}
#line 97 "../src/network/vnstat.vala"
	if (old) {
#line 97 "../src/network/vnstat.vala"
		vnstat_interface_unref (old);
#line 1761 "vnstat.c"
	}
}

static void
vnstat_interface_class_init (VnstatInterfaceClass * klass,
                             gpointer klass_data)
{
#line 97 "../src/network/vnstat.vala"
	vnstat_interface_parent_class = g_type_class_peek_parent (klass);
#line 97 "../src/network/vnstat.vala"
	((VnstatInterfaceClass *) klass)->finalize = vnstat_interface_finalize;
#line 97 "../src/network/vnstat.vala"
	g_type_class_adjust_private_offset (klass, &VnstatInterface_private_offset);
#line 1775 "vnstat.c"
}

static void
vnstat_interface_instance_init (VnstatInterface * self,
                                gpointer klass)
{
#line 97 "../src/network/vnstat.vala"
	self->priv = vnstat_interface_get_instance_private (self);
#line 97 "../src/network/vnstat.vala"
	self->ref_count = 1;
#line 1786 "vnstat.c"
}

static void
vnstat_interface_finalize (VnstatInterface * obj)
{
	VnstatInterface * self;
#line 97 "../src/network/vnstat.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VNSTAT_TYPE_INTERFACE, VnstatInterface);
#line 97 "../src/network/vnstat.vala"
	g_signal_handlers_destroy (self);
#line 98 "../src/network/vnstat.vala"
	_g_free0 (self->priv->_name);
#line 1799 "vnstat.c"
}

static GType
vnstat_interface_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { vnstat_value_interface_init, vnstat_value_interface_free_value, vnstat_value_interface_copy_value, vnstat_value_interface_peek_pointer, "p", vnstat_value_interface_collect_value, "p", vnstat_value_interface_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (VnstatInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vnstat_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VnstatInterface), 0, (GInstanceInitFunc) vnstat_interface_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType vnstat_interface_type_id;
	vnstat_interface_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VnstatInterface", &g_define_type_info, &g_define_type_fundamental_info, 0);
	VnstatInterface_private_offset = g_type_add_instance_private (vnstat_interface_type_id, sizeof (VnstatInterfacePrivate));
	return vnstat_interface_type_id;
}

GType
vnstat_interface_get_type (void)
{
	static volatile gsize vnstat_interface_type_id__once = 0;
	if (g_once_init_enter (&vnstat_interface_type_id__once)) {
		GType vnstat_interface_type_id;
		vnstat_interface_type_id = vnstat_interface_get_type_once ();
		g_once_init_leave (&vnstat_interface_type_id__once, vnstat_interface_type_id);
	}
	return vnstat_interface_type_id__once;
}

gpointer
vnstat_interface_ref (gpointer instance)
{
	VnstatInterface * self;
	self = instance;
#line 97 "../src/network/vnstat.vala"
	g_atomic_int_inc (&self->ref_count);
#line 97 "../src/network/vnstat.vala"
	return instance;
#line 1835 "vnstat.c"
}

void
vnstat_interface_unref (gpointer instance)
{
	VnstatInterface * self;
	self = instance;
#line 97 "../src/network/vnstat.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 97 "../src/network/vnstat.vala"
		VNSTAT_INTERFACE_GET_CLASS (self)->finalize (self);
#line 97 "../src/network/vnstat.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1849 "vnstat.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

