/* process.c generated by valac 0.56.18, the Vala compiler
 * generated from process.vala, do not modify */

/* process.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#define _GNU_SOURCE

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glibtop/procstate.h>
#include <glibtop.h>
#include <glibtop/procuid.h>
#include <glibtop/procargs.h>
#include <gio/gio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define USAGE_TYPE_PROCESS (usage_process_get_type ())
#define USAGE_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_PROCESS, UsageProcess))
#define USAGE_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_PROCESS, UsageProcessClass))
#define USAGE_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_PROCESS))
#define USAGE_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_PROCESS))
#define USAGE_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_PROCESS, UsageProcessClass))

typedef struct _UsageProcess UsageProcess;
typedef struct _UsageProcessClass UsageProcessClass;
typedef struct _UsageProcessPrivate UsageProcessPrivate;
typedef enum  {
	USAGE_PROCESS_STATUS_RUNNING,
	USAGE_PROCESS_STATUS_SLEEPING,
	USAGE_PROCESS_STATUS_DEAD
} UsageProcessStatus;

#define USAGE_TYPE_PROCESS_STATUS (usage_process_status_get_type ())
enum  {
	USAGE_PROCESS_0_PROPERTY,
	USAGE_PROCESS_PID_PROPERTY,
	USAGE_PROCESS_CMDLINE_PROPERTY,
	USAGE_PROCESS_UID_PROPERTY,
	USAGE_PROCESS_START_TIME_PROPERTY,
	USAGE_PROCESS_CGROUP_PROPERTY,
	USAGE_PROCESS_CPU_LOAD_PROPERTY,
	USAGE_PROCESS_X_CPU_LOAD_PROPERTY,
	USAGE_PROCESS_CPU_LAST_USED_PROPERTY,
	USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY,
	USAGE_PROCESS_LAST_PROCESSOR_PROPERTY,
	USAGE_PROCESS_MEM_USAGE_PROPERTY,
	USAGE_PROCESS_GAMEMODE_PROPERTY,
	USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY,
	USAGE_PROCESS_STATUS_PROPERTY,
	USAGE_PROCESS_APP_ID_PROPERTY,
	USAGE_PROCESS_NUM_PROPERTIES
};
static GParamSpec* usage_process_properties[USAGE_PROCESS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_mapped_file_unref0(var) ((var == NULL) ? NULL : (var = (g_mapped_file_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _UsageProcess {
	GObject parent_instance;
	UsageProcessPrivate * priv;
};

struct _UsageProcessClass {
	GObjectClass parent_class;
};

struct _UsageProcessPrivate {
	GPid _pid;
	gchar* _cmdline;
	guint _uid;
	guint64 _start_time;
	gboolean _cgroup_read;
	gchar* _cgroup;
	gdouble _cpu_load;
	gdouble _x_cpu_load;
	guint64 _cpu_last_used;
	guint64 _x_cpu_last_used;
	guint _last_processor;
	guint64 _mem_usage;
	gboolean _gamemode;
	gboolean _mark_as_updated;
	UsageProcessStatus _status;
	gchar* _app_id;
	gboolean _app_id_checked;
};

static gint UsageProcess_private_offset;
static gpointer usage_process_parent_class = NULL;

VALA_EXTERN GType usage_process_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageProcess, g_object_unref)
VALA_EXTERN GType usage_process_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UsageProcess* usage_process_new (GPid pid);
VALA_EXTERN UsageProcess* usage_process_construct (GType object_type,
                                       GPid pid);
static void usage_process_set_pid (UsageProcess* self,
                            GPid value);
VALA_EXTERN gchar* usage_process_get_full_process_cmd (GPid pid);
static void usage_process_set_cmdline (UsageProcess* self,
                                const gchar* value);
static guint _usage_process_get_uid (UsageProcess* self);
static void usage_process_set_uid (UsageProcess* self,
                            guint value);
VALA_EXTERN void usage_process_update_status (UsageProcess* self);
VALA_EXTERN GPid usage_process_get_pid (UsageProcess* self);
static void usage_process_set_status (UsageProcess* self,
                               UsageProcessStatus value);
VALA_EXTERN gdouble usage_process_get_cpu_load (UsageProcess* self);
VALA_EXTERN void usage_process_set_mark_as_updated (UsageProcess* self,
                                        gboolean value);
VALA_EXTERN gchar* usage_process_first_component (const gchar* str);
VALA_EXTERN gchar* usage_process_sanitize_name (const gchar* name);
VALA_EXTERN gchar* usage_process_read_cgroup (GPid pid);
VALA_EXTERN gchar* usage_process_read_app_id (GPid pid);
VALA_EXTERN GKeyFile* usage_process_read_flatpak_info (GPid pid);
VALA_EXTERN const gchar* usage_process_get_cmdline (UsageProcess* self);
VALA_EXTERN guint usage_process_get_uid (UsageProcess* self);
VALA_EXTERN guint64 usage_process_get_start_time (UsageProcess* self);
VALA_EXTERN void usage_process_set_start_time (UsageProcess* self,
                                   guint64 value);
VALA_EXTERN const gchar* usage_process_get_cgroup (UsageProcess* self);
VALA_EXTERN void usage_process_set_cpu_load (UsageProcess* self,
                                 gdouble value);
VALA_EXTERN gdouble usage_process_get_x_cpu_load (UsageProcess* self);
VALA_EXTERN void usage_process_set_x_cpu_load (UsageProcess* self,
                                   gdouble value);
VALA_EXTERN guint64 usage_process_get_cpu_last_used (UsageProcess* self);
VALA_EXTERN void usage_process_set_cpu_last_used (UsageProcess* self,
                                      guint64 value);
VALA_EXTERN guint64 usage_process_get_x_cpu_last_used (UsageProcess* self);
VALA_EXTERN void usage_process_set_x_cpu_last_used (UsageProcess* self,
                                        guint64 value);
VALA_EXTERN guint usage_process_get_last_processor (UsageProcess* self);
VALA_EXTERN void usage_process_set_last_processor (UsageProcess* self,
                                       guint value);
VALA_EXTERN guint64 usage_process_get_mem_usage (UsageProcess* self);
VALA_EXTERN void usage_process_set_mem_usage (UsageProcess* self,
                                  guint64 value);
VALA_EXTERN gboolean usage_process_get_gamemode (UsageProcess* self);
VALA_EXTERN void usage_process_set_gamemode (UsageProcess* self,
                                 gboolean value);
VALA_EXTERN gboolean usage_process_get_mark_as_updated (UsageProcess* self);
VALA_EXTERN UsageProcessStatus usage_process_get_status (UsageProcess* self);
VALA_EXTERN const gchar* usage_process_get_app_id (UsageProcess* self);
static void usage_process_finalize (GObject * obj);
static GType usage_process_get_type_once (void);
static void _vala_usage_process_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_usage_process_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
usage_process_get_instance_private (UsageProcess* self)
{
	return G_STRUCT_MEMBER_P (self, UsageProcess_private_offset);
}

UsageProcess*
usage_process_construct (GType object_type,
                         GPid pid)
{
	UsageProcess * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 56 "../src/process.vala"
	self = (UsageProcess*) g_object_new (object_type, NULL);
#line 57 "../src/process.vala"
	usage_process_set_pid (self, pid);
#line 58 "../src/process.vala"
	_tmp0_ = usage_process_get_full_process_cmd (pid);
#line 58 "../src/process.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/process.vala"
	usage_process_set_cmdline (self, _tmp1_);
#line 58 "../src/process.vala"
	_g_free0 (_tmp1_);
#line 59 "../src/process.vala"
	usage_process_set_uid (self, _usage_process_get_uid (self));
#line 56 "../src/process.vala"
	return self;
#line 240 "process.c"
}

UsageProcess*
usage_process_new (GPid pid)
{
#line 56 "../src/process.vala"
	return usage_process_construct (USAGE_TYPE_PROCESS, pid);
#line 248 "process.c"
}

void
usage_process_update_status (UsageProcess* self)
{
	glibtop_proc_state proc_state = {0};
	GPid _tmp0_;
	glibtop_proc_state _tmp1_ = {0};
	glibtop_proc_state _tmp2_;
#line 62 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/process.vala"
	_tmp0_ = self->priv->_pid;
#line 64 "../src/process.vala"
	glibtop_get_proc_state (&_tmp1_, _tmp0_);
#line 64 "../src/process.vala"
	proc_state = _tmp1_;
#line 66 "../src/process.vala"
	_tmp2_ = proc_state;
#line 66 "../src/process.vala"
	switch (_tmp2_.state) {
#line 66 "../src/process.vala"
		case GLIBTOP_PROCESS_RUNNING:
#line 66 "../src/process.vala"
		case GLIBTOP_PROCESS_UNINTERRUPTIBLE:
#line 274 "process.c"
		{
#line 69 "../src/process.vala"
			usage_process_set_status (self, USAGE_PROCESS_STATUS_RUNNING);
#line 70 "../src/process.vala"
			break;
#line 280 "process.c"
		}
#line 66 "../src/process.vala"
		case GLIBTOP_PROCESS_SWAPPING:
#line 66 "../src/process.vala"
		case GLIBTOP_PROCESS_INTERRUPTIBLE:
#line 66 "../src/process.vala"
		case GLIBTOP_PROCESS_STOPPED:
#line 288 "process.c"
		{
#line 74 "../src/process.vala"
			usage_process_set_status (self, USAGE_PROCESS_STATUS_SLEEPING);
#line 75 "../src/process.vala"
			break;
#line 294 "process.c"
		}
		default:
#line 66 "../src/process.vala"
		case GLIBTOP_PROCESS_DEAD:
#line 66 "../src/process.vala"
		case GLIBTOP_PROCESS_ZOMBIE:
#line 301 "process.c"
		{
			gdouble _tmp3_;
#line 79 "../src/process.vala"
			_tmp3_ = self->priv->_cpu_load;
#line 79 "../src/process.vala"
			if (_tmp3_ > ((gdouble) 0)) {
#line 80 "../src/process.vala"
				usage_process_set_status (self, USAGE_PROCESS_STATUS_RUNNING);
#line 310 "process.c"
			} else {
#line 82 "../src/process.vala"
				usage_process_set_status (self, USAGE_PROCESS_STATUS_DEAD);
#line 314 "process.c"
			}
#line 84 "../src/process.vala"
			break;
#line 318 "process.c"
		}
	}
#line 87 "../src/process.vala"
	usage_process_set_mark_as_updated (self, TRUE);
#line 323 "process.c"
}

static guint
_usage_process_get_uid (UsageProcess* self)
{
	glibtop_proc_uid procUid = {0};
	GPid _tmp0_;
	glibtop_proc_uid _tmp1_ = {0};
	glibtop_proc_uid _tmp2_;
	guint result;
#line 90 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 92 "../src/process.vala"
	_tmp0_ = self->priv->_pid;
#line 92 "../src/process.vala"
	glibtop_get_proc_uid (&_tmp1_, _tmp0_);
#line 92 "../src/process.vala"
	procUid = _tmp1_;
#line 93 "../src/process.vala"
	_tmp2_ = procUid;
#line 93 "../src/process.vala"
	result = (guint) _tmp2_.uid;
#line 93 "../src/process.vala"
	return result;
#line 348 "process.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 367 "process.c"
}

gchar*
usage_process_get_full_process_cmd (GPid pid)
{
	glibtop_proc_args proc_args = {0};
	glibtop_proc_state proc_state = {0};
	gchar** args = NULL;
	glibtop_proc_args _tmp0_ = {0};
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint args_length1;
	gint _args_size_;
	glibtop_proc_state _tmp3_ = {0};
	gchar* cmd = NULL;
	glibtop_proc_state _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* result;
#line 111 "../src/process.vala"
	_tmp2_ = _tmp1_ = glibtop_get_proc_argv (&_tmp0_, pid, (guint) 0);
#line 111 "../src/process.vala"
	proc_args = _tmp0_;
#line 111 "../src/process.vala"
	args = _tmp2_;
#line 111 "../src/process.vala"
	args_length1 = _vala_array_length (_tmp1_);
#line 111 "../src/process.vala"
	_args_size_ = args_length1;
#line 112 "../src/process.vala"
	glibtop_get_proc_state (&_tmp3_, pid);
#line 112 "../src/process.vala"
	proc_state = _tmp3_;
#line 113 "../src/process.vala"
	_tmp4_ = proc_state;
#line 113 "../src/process.vala"
	_tmp5_ = g_strdup ((const gchar*) _tmp4_.cmd);
#line 113 "../src/process.vala"
	cmd = _tmp5_;
#line 408 "process.c"
	{
		gint i = 0;
#line 118 "../src/process.vala"
		i = 0;
#line 413 "process.c"
		{
			gboolean _tmp6_ = FALSE;
#line 118 "../src/process.vala"
			_tmp6_ = TRUE;
#line 118 "../src/process.vala"
			while (TRUE) {
#line 420 "process.c"
				gchar** _tmp8_;
				gint _tmp8__length1;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				gchar* name = NULL;
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
#line 118 "../src/process.vala"
				if (!_tmp6_) {
#line 439 "process.c"
					gint _tmp7_;
#line 118 "../src/process.vala"
					_tmp7_ = i;
#line 118 "../src/process.vala"
					i = _tmp7_ + 1;
#line 445 "process.c"
				}
#line 118 "../src/process.vala"
				_tmp6_ = FALSE;
#line 118 "../src/process.vala"
				_tmp8_ = args;
#line 118 "../src/process.vala"
				_tmp8__length1 = args_length1;
#line 118 "../src/process.vala"
				if (!(((guint) i) < MIN ((guint) _tmp8__length1, (guint) 2))) {
#line 118 "../src/process.vala"
					break;
#line 457 "process.c"
				}
#line 119 "../src/process.vala"
				_tmp9_ = args;
#line 119 "../src/process.vala"
				_tmp9__length1 = args_length1;
#line 119 "../src/process.vala"
				_tmp10_ = _tmp9_[i];
#line 119 "../src/process.vala"
				if (_tmp10_ == NULL) {
#line 120 "../src/process.vala"
					continue;
#line 469 "process.c"
				}
#line 125 "../src/process.vala"
				_tmp11_ = args;
#line 125 "../src/process.vala"
				_tmp11__length1 = args_length1;
#line 125 "../src/process.vala"
				_tmp12_ = _tmp11_[i];
#line 125 "../src/process.vala"
				_tmp13_ = g_path_get_basename (_tmp12_);
#line 125 "../src/process.vala"
				name = _tmp13_;
#line 126 "../src/process.vala"
				_tmp14_ = name;
#line 126 "../src/process.vala"
				_tmp15_ = cmd;
#line 126 "../src/process.vala"
				if (!string_contains (_tmp14_, _tmp15_)) {
#line 127 "../src/process.vala"
					_g_free0 (name);
#line 127 "../src/process.vala"
					continue;
#line 491 "process.c"
				}
#line 129 "../src/process.vala"
				_tmp16_ = name;
#line 129 "../src/process.vala"
				_tmp17_ = usage_process_first_component (_tmp16_);
#line 129 "../src/process.vala"
				_g_free0 (name);
#line 129 "../src/process.vala"
				name = _tmp17_;
#line 130 "../src/process.vala"
				_tmp18_ = name;
#line 130 "../src/process.vala"
				_tmp19_ = usage_process_sanitize_name (_tmp18_);
#line 130 "../src/process.vala"
				result = _tmp19_;
#line 130 "../src/process.vala"
				_g_free0 (name);
#line 130 "../src/process.vala"
				_g_free0 (cmd);
#line 130 "../src/process.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 130 "../src/process.vala"
				return result;
#line 515 "process.c"
			}
		}
	}
#line 133 "../src/process.vala"
	_tmp20_ = cmd;
#line 133 "../src/process.vala"
	_tmp21_ = usage_process_sanitize_name (_tmp20_);
#line 133 "../src/process.vala"
	result = _tmp21_;
#line 133 "../src/process.vala"
	_g_free0 (cmd);
#line 133 "../src/process.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 133 "../src/process.vala"
	return result;
#line 531 "process.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 558 "process.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 564 "process.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 570 "process.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 574 "process.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 582 "process.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 586 "process.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 598 "process.c"
}

gchar*
usage_process_read_cgroup (GPid pid)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 137 "../src/process.vala"
	_tmp0_ = g_strdup_printf ("/proc/%u/cgroup", (guint) pid);
#line 137 "../src/process.vala"
	path = _tmp0_;
#line 612 "process.c"
	{
		GFile* file = NULL;
		const gchar* _tmp1_;
		GFile* _tmp2_;
		guint8* contents = NULL;
		gint contents_length1 = 0;
		gint _contents_size_ = 0;
		GFile* _tmp3_;
		guint8* _tmp4_ = NULL;
		gsize _tmp5_ = 0;
		gchar* line = NULL;
		guint8* _tmp6_;
		gint _tmp6__length1;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
#line 140 "../src/process.vala"
		_tmp1_ = path;
#line 140 "../src/process.vala"
		_tmp2_ = g_file_new_for_path (_tmp1_);
#line 140 "../src/process.vala"
		file = _tmp2_;
#line 143 "../src/process.vala"
		_tmp3_ = file;
#line 143 "../src/process.vala"
		g_file_load_contents (_tmp3_, NULL, &_tmp4_, &_tmp5_, NULL, &_inner_error0_);
#line 143 "../src/process.vala"
		contents = (g_free (contents), NULL);
#line 143 "../src/process.vala"
		contents = _tmp4_;
#line 143 "../src/process.vala"
		contents_length1 = _tmp5_;
#line 143 "../src/process.vala"
		_contents_size_ = contents_length1;
#line 143 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../src/process.vala"
			contents = (g_free (contents), NULL);
#line 143 "../src/process.vala"
			_g_object_unref0 (file);
#line 663 "process.c"
			goto __catch0_g_error;
		}
#line 145 "../src/process.vala"
		_tmp6_ = contents;
#line 145 "../src/process.vala"
		_tmp6__length1 = contents_length1;
#line 145 "../src/process.vala"
		_tmp8_ = _tmp7_ = g_strsplit ((const gchar*) _tmp6_, "\n", 0);
#line 145 "../src/process.vala"
		_tmp9_ = _tmp8_;
#line 145 "../src/process.vala"
		_tmp9__length1 = _vala_array_length (_tmp7_);
#line 145 "../src/process.vala"
		_tmp10_ = _tmp9_[0];
#line 145 "../src/process.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 145 "../src/process.vala"
		_tmp12_ = _tmp11_;
#line 145 "../src/process.vala"
		_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 145 "../src/process.vala"
		line = _tmp12_;
#line 148 "../src/process.vala"
		_tmp13_ = line;
#line 148 "../src/process.vala"
		if (!g_str_has_prefix (_tmp13_, "0::")) {
#line 149 "../src/process.vala"
			result = NULL;
#line 149 "../src/process.vala"
			_g_free0 (line);
#line 149 "../src/process.vala"
			contents = (g_free (contents), NULL);
#line 149 "../src/process.vala"
			_g_object_unref0 (file);
#line 149 "../src/process.vala"
			_g_free0 (path);
#line 149 "../src/process.vala"
			return result;
#line 702 "process.c"
		}
#line 151 "../src/process.vala"
		_tmp14_ = line;
#line 151 "../src/process.vala"
		_tmp15_ = line;
#line 151 "../src/process.vala"
		_tmp16_ = strlen (_tmp15_);
#line 151 "../src/process.vala"
		_tmp17_ = _tmp16_;
#line 151 "../src/process.vala"
		_tmp18_ = string_slice (_tmp14_, (glong) 3, (glong) _tmp17_);
#line 151 "../src/process.vala"
		result = _tmp18_;
#line 151 "../src/process.vala"
		_g_free0 (line);
#line 151 "../src/process.vala"
		contents = (g_free (contents), NULL);
#line 151 "../src/process.vala"
		_g_object_unref0 (file);
#line 151 "../src/process.vala"
		_g_free0 (path);
#line 151 "../src/process.vala"
		return result;
#line 726 "process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 139 "../src/process.vala"
		g_clear_error (&_inner_error0_);
#line 153 "../src/process.vala"
		result = NULL;
#line 153 "../src/process.vala"
		_g_free0 (path);
#line 153 "../src/process.vala"
		return result;
#line 739 "process.c"
	}
	__finally0:
#line 139 "../src/process.vala"
	_g_free0 (path);
#line 139 "../src/process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 139 "../src/process.vala"
	g_clear_error (&_inner_error0_);
#line 139 "../src/process.vala"
	return NULL;
#line 750 "process.c"
}

gchar*
usage_process_read_app_id (GPid pid)
{
	GKeyFile* kf = NULL;
	GKeyFile* _tmp0_;
	GKeyFile* _tmp1_;
	gchar* name = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 158 "../src/process.vala"
	_tmp0_ = usage_process_read_flatpak_info (pid);
#line 158 "../src/process.vala"
	kf = _tmp0_;
#line 160 "../src/process.vala"
	_tmp1_ = kf;
#line 160 "../src/process.vala"
	if (_tmp1_ == NULL) {
#line 161 "../src/process.vala"
		result = NULL;
#line 161 "../src/process.vala"
		_g_key_file_unref0 (kf);
#line 161 "../src/process.vala"
		return result;
#line 776 "process.c"
	}
#line 163 "../src/process.vala"
	name = NULL;
#line 780 "process.c"
	{
		gboolean _tmp2_ = FALSE;
		GKeyFile* _tmp3_;
#line 165 "../src/process.vala"
		_tmp3_ = kf;
#line 165 "../src/process.vala"
		_tmp2_ = g_key_file_has_key (_tmp3_, "Application", "name", &_inner_error0_);
#line 165 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 790 "process.c"
			goto __catch0_g_error;
		}
#line 165 "../src/process.vala"
		if (_tmp2_) {
#line 795 "process.c"
			gchar* _tmp4_ = NULL;
			GKeyFile* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 166 "../src/process.vala"
			_tmp5_ = kf;
#line 166 "../src/process.vala"
			_tmp6_ = g_key_file_get_string (_tmp5_, "Application", "name", &_inner_error0_);
#line 166 "../src/process.vala"
			_tmp4_ = _tmp6_;
#line 166 "../src/process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 808 "process.c"
				goto __catch0_g_error;
			}
#line 166 "../src/process.vala"
			_tmp7_ = _tmp4_;
#line 166 "../src/process.vala"
			_tmp4_ = NULL;
#line 166 "../src/process.vala"
			_g_free0 (name);
#line 166 "../src/process.vala"
			name = _tmp7_;
#line 165 "../src/process.vala"
			_g_free0 (_tmp4_);
#line 821 "process.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 164 "../src/process.vala"
		g_clear_error (&_inner_error0_);
#line 168 "../src/process.vala"
		_tmp8_ = g_strdup_printf ("%i", (gint) pid);
#line 168 "../src/process.vala"
		_tmp9_ = _tmp8_;
#line 168 "../src/process.vala"
		_tmp10_ = g_strconcat ("Failed to parse faltpak info for: ", _tmp9_, NULL);
#line 168 "../src/process.vala"
		_tmp11_ = _tmp10_;
#line 168 "../src/process.vala"
		g_warning ("process.vala:168: %s", _tmp11_);
#line 168 "../src/process.vala"
		_g_free0 (_tmp11_);
#line 168 "../src/process.vala"
		_g_free0 (_tmp9_);
#line 847 "process.c"
	}
	__finally0:
#line 164 "../src/process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../src/process.vala"
		_g_free0 (name);
#line 164 "../src/process.vala"
		_g_key_file_unref0 (kf);
#line 164 "../src/process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../src/process.vala"
		g_clear_error (&_inner_error0_);
#line 164 "../src/process.vala"
		return NULL;
#line 862 "process.c"
	}
#line 171 "../src/process.vala"
	result = name;
#line 171 "../src/process.vala"
	_g_key_file_unref0 (kf);
#line 171 "../src/process.vala"
	return result;
#line 870 "process.c"
}

GKeyFile*
usage_process_read_flatpak_info (GPid pid)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gint flags = 0;
	gint root = 0;
	const gchar* _tmp1_;
	gint fd = 0;
	GKeyFile* kf = NULL;
	GKeyFile* _tmp2_;
	GError* _inner_error0_ = NULL;
	GKeyFile* result;
#line 175 "../src/process.vala"
	_tmp0_ = g_strdup_printf ("/proc/%u/root", (guint) pid);
#line 175 "../src/process.vala"
	path = _tmp0_;
#line 176 "../src/process.vala"
	flags = (O_RDONLY | O_CLOEXEC) | O_NOCTTY;
#line 178 "../src/process.vala"
	_tmp1_ = path;
#line 178 "../src/process.vala"
	root = openat (AT_FDCWD, _tmp1_, (flags | O_NONBLOCK) | O_DIRECTORY, (mode_t) 0);
#line 180 "../src/process.vala"
	if (root == -1) {
#line 181 "../src/process.vala"
		result = NULL;
#line 181 "../src/process.vala"
		_g_free0 (path);
#line 181 "../src/process.vala"
		return result;
#line 904 "process.c"
	}
#line 183 "../src/process.vala"
	fd = openat (root, ".flatpak-info", flags, (mode_t) 0);
#line 185 "../src/process.vala"
	close (root);
#line 187 "../src/process.vala"
	if (fd == -1) {
#line 188 "../src/process.vala"
		result = NULL;
#line 188 "../src/process.vala"
		_g_free0 (path);
#line 188 "../src/process.vala"
		return result;
#line 918 "process.c"
	}
#line 190 "../src/process.vala"
	_tmp2_ = g_key_file_new ();
#line 190 "../src/process.vala"
	kf = _tmp2_;
#line 924 "process.c"
	{
		GMappedFile* file = NULL;
		GMappedFile* _tmp3_;
		GKeyFile* _tmp4_;
		GMappedFile* _tmp5_;
		gchar* _tmp6_;
		GMappedFile* _tmp7_;
#line 193 "../src/process.vala"
		_tmp3_ = g_mapped_file_new_from_fd (fd, FALSE, &_inner_error0_);
#line 193 "../src/process.vala"
		file = _tmp3_;
#line 193 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 938 "process.c"
			goto __catch0_g_error;
		}
#line 194 "../src/process.vala"
		_tmp4_ = kf;
#line 194 "../src/process.vala"
		_tmp5_ = file;
#line 194 "../src/process.vala"
		_tmp6_ = g_mapped_file_get_contents (_tmp5_);
#line 194 "../src/process.vala"
		_tmp7_ = file;
#line 194 "../src/process.vala"
		g_key_file_load_from_data (_tmp4_, (const gchar*) _tmp6_, g_mapped_file_get_length (_tmp7_), 0, &_inner_error0_);
#line 194 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../src/process.vala"
			_g_mapped_file_unref0 (file);
#line 955 "process.c"
			goto __catch0_g_error;
		}
#line 192 "../src/process.vala"
		_g_mapped_file_unref0 (file);
#line 960 "process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 192 "../src/process.vala"
		g_clear_error (&_inner_error0_);
#line 196 "../src/process.vala"
		result = NULL;
#line 196 "../src/process.vala"
		_g_key_file_unref0 (kf);
#line 196 "../src/process.vala"
		_g_free0 (path);
#line 196 "../src/process.vala"
		return result;
#line 975 "process.c"
	}
	__finally0:
#line 192 "../src/process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "../src/process.vala"
		_g_key_file_unref0 (kf);
#line 192 "../src/process.vala"
		_g_free0 (path);
#line 192 "../src/process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "../src/process.vala"
		g_clear_error (&_inner_error0_);
#line 192 "../src/process.vala"
		return NULL;
#line 990 "process.c"
	}
#line 199 "../src/process.vala"
	result = kf;
#line 199 "../src/process.vala"
	_g_free0 (path);
#line 199 "../src/process.vala"
	return result;
#line 998 "process.c"
}

gchar*
usage_process_sanitize_name (const gchar* name)
{
	gchar* _result_ = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 203 "../src/process.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 204 "../src/process.vala"
	_result_ = NULL;
#line 206 "../src/process.vala"
	if (name == NULL) {
#line 207 "../src/process.vala"
		result = NULL;
#line 207 "../src/process.vala"
		_g_free0 (_result_);
#line 207 "../src/process.vala"
		return result;
#line 1019 "process.c"
	}
	{
		GRegex* rgx = NULL;
		GRegex* _tmp0_;
		gchar* _tmp1_ = NULL;
		GRegex* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 210 "../src/process.vala"
		_tmp0_ = g_regex_new ("[^a-zA-Z0-9._-]", 0, 0, &_inner_error0_);
#line 210 "../src/process.vala"
		rgx = _tmp0_;
#line 210 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 210 "../src/process.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1038 "process.c"
				goto __catch0_g_regex_error;
			}
#line 210 "../src/process.vala"
			_g_free0 (_result_);
#line 210 "../src/process.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 210 "../src/process.vala"
			g_clear_error (&_inner_error0_);
#line 210 "../src/process.vala"
			return NULL;
#line 1049 "process.c"
		}
#line 211 "../src/process.vala"
		_tmp2_ = rgx;
#line 211 "../src/process.vala"
		_tmp3_ = strlen (name);
#line 211 "../src/process.vala"
		_tmp4_ = _tmp3_;
#line 211 "../src/process.vala"
		_tmp5_ = g_regex_replace (_tmp2_, name, (gssize) _tmp4_, 0, "", 0, &_inner_error0_);
#line 211 "../src/process.vala"
		_tmp1_ = _tmp5_;
#line 211 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 211 "../src/process.vala"
			_g_regex_unref0 (rgx);
#line 211 "../src/process.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1067 "process.c"
				goto __catch0_g_regex_error;
			}
#line 211 "../src/process.vala"
			_g_free0 (_result_);
#line 211 "../src/process.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 211 "../src/process.vala"
			g_clear_error (&_inner_error0_);
#line 211 "../src/process.vala"
			return NULL;
#line 1078 "process.c"
		}
#line 211 "../src/process.vala"
		_tmp6_ = _tmp1_;
#line 211 "../src/process.vala"
		_tmp1_ = NULL;
#line 211 "../src/process.vala"
		_g_free0 (_result_);
#line 211 "../src/process.vala"
		_result_ = _tmp6_;
#line 209 "../src/process.vala"
		_g_free0 (_tmp1_);
#line 209 "../src/process.vala"
		_g_regex_unref0 (rgx);
#line 1092 "process.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 209 "../src/process.vala"
		e = _inner_error0_;
#line 209 "../src/process.vala"
		_inner_error0_ = NULL;
#line 213 "../src/process.vala"
		_tmp7_ = e;
#line 213 "../src/process.vala"
		_tmp8_ = _tmp7_->message;
#line 213 "../src/process.vala"
		g_warning ("process.vala:213: Unable to sanitize name: %s", _tmp8_);
#line 209 "../src/process.vala"
		_g_error_free0 (e);
#line 1112 "process.c"
	}
	__finally0:
#line 209 "../src/process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 209 "../src/process.vala"
		_g_free0 (_result_);
#line 209 "../src/process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 209 "../src/process.vala"
		g_clear_error (&_inner_error0_);
#line 209 "../src/process.vala"
		return NULL;
#line 1125 "process.c"
	}
#line 216 "../src/process.vala"
	result = _result_;
#line 216 "../src/process.vala"
	return result;
#line 1131 "process.c"
}

gchar*
usage_process_first_component (const gchar* str)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 219 "../src/process.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 220 "../src/process.vala"
	_tmp1_ = _tmp0_ = g_strsplit (str, " ", 2);
#line 220 "../src/process.vala"
	_tmp2_ = _tmp1_;
#line 220 "../src/process.vala"
	_tmp2__length1 = _vala_array_length (_tmp0_);
#line 220 "../src/process.vala"
	_tmp3_ = _tmp2_[0];
#line 220 "../src/process.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 220 "../src/process.vala"
	_tmp5_ = _tmp4_;
#line 220 "../src/process.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 220 "../src/process.vala"
	result = _tmp5_;
#line 220 "../src/process.vala"
	return result;
#line 1165 "process.c"
}

GPid
usage_process_get_pid (UsageProcess* self)
{
	GPid result;
#line 22 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 22 "../src/process.vala"
	result = self->priv->_pid;
#line 22 "../src/process.vala"
	return result;
#line 1178 "process.c"
}

static void
usage_process_set_pid (UsageProcess* self,
                       GPid value)
{
	GPid old_value;
#line 22 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/process.vala"
	old_value = usage_process_get_pid (self);
#line 22 "../src/process.vala"
	if (old_value != value) {
#line 22 "../src/process.vala"
		self->priv->_pid = value;
#line 22 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_PID_PROPERTY]);
#line 1196 "process.c"
	}
}

const gchar*
usage_process_get_cmdline (UsageProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/process.vala"
	_tmp0_ = self->priv->_cmdline;
#line 23 "../src/process.vala"
	result = _tmp0_;
#line 23 "../src/process.vala"
	return result;
#line 1213 "process.c"
}

static void
usage_process_set_cmdline (UsageProcess* self,
                           const gchar* value)
{
	gchar* old_value;
#line 23 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/process.vala"
	old_value = usage_process_get_cmdline (self);
#line 23 "../src/process.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1227 "process.c"
		gchar* _tmp0_;
#line 23 "../src/process.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/process.vala"
		_g_free0 (self->priv->_cmdline);
#line 23 "../src/process.vala"
		self->priv->_cmdline = _tmp0_;
#line 23 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CMDLINE_PROPERTY]);
#line 1237 "process.c"
	}
}

guint
usage_process_get_uid (UsageProcess* self)
{
	guint result;
#line 24 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 24 "../src/process.vala"
	result = self->priv->_uid;
#line 24 "../src/process.vala"
	return result;
#line 1251 "process.c"
}

static void
usage_process_set_uid (UsageProcess* self,
                       guint value)
{
	guint old_value;
#line 24 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/process.vala"
	old_value = usage_process_get_uid (self);
#line 24 "../src/process.vala"
	if (old_value != value) {
#line 24 "../src/process.vala"
		self->priv->_uid = value;
#line 24 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_UID_PROPERTY]);
#line 1269 "process.c"
	}
}

guint64
usage_process_get_start_time (UsageProcess* self)
{
	guint64 result;
#line 25 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 25 "../src/process.vala"
	result = self->priv->_start_time;
#line 25 "../src/process.vala"
	return result;
#line 1283 "process.c"
}

void
usage_process_set_start_time (UsageProcess* self,
                              guint64 value)
{
	guint64 old_value;
#line 25 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/process.vala"
	old_value = usage_process_get_start_time (self);
#line 25 "../src/process.vala"
	if (old_value != value) {
#line 25 "../src/process.vala"
		self->priv->_start_time = value;
#line 25 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_START_TIME_PROPERTY]);
#line 1301 "process.c"
	}
}

const gchar*
usage_process_get_cgroup (UsageProcess* self)
{
	const gchar* result;
	const gchar* _tmp2_;
#line 30 "../src/process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/process.vala"
	if (!self->priv->_cgroup_read) {
#line 1314 "process.c"
		GPid _tmp0_;
		gchar* _tmp1_;
#line 32 "../src/process.vala"
		_tmp0_ = self->priv->_pid;
#line 32 "../src/process.vala"
		_tmp1_ = usage_process_read_cgroup (_tmp0_);
#line 32 "../src/process.vala"
		_g_free0 (self->priv->_cgroup);
#line 32 "../src/process.vala"
		self->priv->_cgroup = _tmp1_;
#line 33 "../src/process.vala"
		self->priv->_cgroup_read = TRUE;
#line 1327 "process.c"
	}
#line 36 "../src/process.vala"
	_tmp2_ = self->priv->_cgroup;
#line 36 "../src/process.vala"
	result = _tmp2_;
#line 36 "../src/process.vala"
	return result;
#line 1335 "process.c"
}

gdouble
usage_process_get_cpu_load (UsageProcess* self)
{
	gdouble result;
#line 40 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 40 "../src/process.vala"
	result = self->priv->_cpu_load;
#line 40 "../src/process.vala"
	return result;
#line 1348 "process.c"
}

void
usage_process_set_cpu_load (UsageProcess* self,
                            gdouble value)
{
	gdouble old_value;
#line 40 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/process.vala"
	old_value = usage_process_get_cpu_load (self);
#line 40 "../src/process.vala"
	if (old_value != value) {
#line 40 "../src/process.vala"
		self->priv->_cpu_load = value;
#line 40 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CPU_LOAD_PROPERTY]);
#line 1366 "process.c"
	}
}

gdouble
usage_process_get_x_cpu_load (UsageProcess* self)
{
	gdouble result;
#line 41 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 41 "../src/process.vala"
	result = self->priv->_x_cpu_load;
#line 41 "../src/process.vala"
	return result;
#line 1380 "process.c"
}

void
usage_process_set_x_cpu_load (UsageProcess* self,
                              gdouble value)
{
	gdouble old_value;
#line 41 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/process.vala"
	old_value = usage_process_get_x_cpu_load (self);
#line 41 "../src/process.vala"
	if (old_value != value) {
#line 41 "../src/process.vala"
		self->priv->_x_cpu_load = value;
#line 41 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_X_CPU_LOAD_PROPERTY]);
#line 1398 "process.c"
	}
}

guint64
usage_process_get_cpu_last_used (UsageProcess* self)
{
	guint64 result;
#line 42 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 42 "../src/process.vala"
	result = self->priv->_cpu_last_used;
#line 42 "../src/process.vala"
	return result;
#line 1412 "process.c"
}

void
usage_process_set_cpu_last_used (UsageProcess* self,
                                 guint64 value)
{
	guint64 old_value;
#line 42 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/process.vala"
	old_value = usage_process_get_cpu_last_used (self);
#line 42 "../src/process.vala"
	if (old_value != value) {
#line 42 "../src/process.vala"
		self->priv->_cpu_last_used = value;
#line 42 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CPU_LAST_USED_PROPERTY]);
#line 1430 "process.c"
	}
}

guint64
usage_process_get_x_cpu_last_used (UsageProcess* self)
{
	guint64 result;
#line 43 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 43 "../src/process.vala"
	result = self->priv->_x_cpu_last_used;
#line 43 "../src/process.vala"
	return result;
#line 1444 "process.c"
}

void
usage_process_set_x_cpu_last_used (UsageProcess* self,
                                   guint64 value)
{
	guint64 old_value;
#line 43 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/process.vala"
	old_value = usage_process_get_x_cpu_last_used (self);
#line 43 "../src/process.vala"
	if (old_value != value) {
#line 43 "../src/process.vala"
		self->priv->_x_cpu_last_used = value;
#line 43 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY]);
#line 1462 "process.c"
	}
}

guint
usage_process_get_last_processor (UsageProcess* self)
{
	guint result;
#line 44 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 44 "../src/process.vala"
	result = self->priv->_last_processor;
#line 44 "../src/process.vala"
	return result;
#line 1476 "process.c"
}

void
usage_process_set_last_processor (UsageProcess* self,
                                  guint value)
{
	guint old_value;
#line 44 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/process.vala"
	old_value = usage_process_get_last_processor (self);
#line 44 "../src/process.vala"
	if (old_value != value) {
#line 44 "../src/process.vala"
		self->priv->_last_processor = value;
#line 44 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_LAST_PROCESSOR_PROPERTY]);
#line 1494 "process.c"
	}
}

guint64
usage_process_get_mem_usage (UsageProcess* self)
{
	guint64 result;
#line 46 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 46 "../src/process.vala"
	result = self->priv->_mem_usage;
#line 46 "../src/process.vala"
	return result;
#line 1508 "process.c"
}

void
usage_process_set_mem_usage (UsageProcess* self,
                             guint64 value)
{
	guint64 old_value;
#line 46 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/process.vala"
	old_value = usage_process_get_mem_usage (self);
#line 46 "../src/process.vala"
	if (old_value != value) {
#line 46 "../src/process.vala"
		self->priv->_mem_usage = value;
#line 46 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_MEM_USAGE_PROPERTY]);
#line 1526 "process.c"
	}
}

gboolean
usage_process_get_gamemode (UsageProcess* self)
{
	gboolean result;
#line 48 "../src/process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/process.vala"
	result = self->priv->_gamemode;
#line 48 "../src/process.vala"
	return result;
#line 1540 "process.c"
}

void
usage_process_set_gamemode (UsageProcess* self,
                            gboolean value)
{
	gboolean old_value;
#line 48 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/process.vala"
	old_value = usage_process_get_gamemode (self);
#line 48 "../src/process.vala"
	if (old_value != value) {
#line 48 "../src/process.vala"
		self->priv->_gamemode = value;
#line 48 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_GAMEMODE_PROPERTY]);
#line 1558 "process.c"
	}
}

gboolean
usage_process_get_mark_as_updated (UsageProcess* self)
{
	gboolean result;
#line 50 "../src/process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/process.vala"
	result = self->priv->_mark_as_updated;
#line 50 "../src/process.vala"
	return result;
#line 1572 "process.c"
}

void
usage_process_set_mark_as_updated (UsageProcess* self,
                                   gboolean value)
{
	gboolean old_value;
#line 50 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/process.vala"
	old_value = usage_process_get_mark_as_updated (self);
#line 50 "../src/process.vala"
	if (old_value != value) {
#line 50 "../src/process.vala"
		self->priv->_mark_as_updated = value;
#line 50 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY]);
#line 1590 "process.c"
	}
}

UsageProcessStatus
usage_process_get_status (UsageProcess* self)
{
	UsageProcessStatus result;
#line 51 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 51 "../src/process.vala"
	result = self->priv->_status;
#line 51 "../src/process.vala"
	return result;
#line 1604 "process.c"
}

static void
usage_process_set_status (UsageProcess* self,
                          UsageProcessStatus value)
{
	UsageProcessStatus old_value;
#line 51 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/process.vala"
	old_value = usage_process_get_status (self);
#line 51 "../src/process.vala"
	if (old_value != value) {
#line 51 "../src/process.vala"
		self->priv->_status = value;
#line 51 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_STATUS_PROPERTY]);
#line 1622 "process.c"
	}
}

const gchar*
usage_process_get_app_id (UsageProcess* self)
{
	const gchar* result;
	const gchar* _tmp2_;
#line 97 "../src/process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../src/process.vala"
	if (!self->priv->_app_id_checked) {
#line 1635 "process.c"
		GPid _tmp0_;
		gchar* _tmp1_;
#line 99 "../src/process.vala"
		_tmp0_ = self->priv->_pid;
#line 99 "../src/process.vala"
		_tmp1_ = usage_process_read_app_id (_tmp0_);
#line 99 "../src/process.vala"
		_g_free0 (self->priv->_app_id);
#line 99 "../src/process.vala"
		self->priv->_app_id = _tmp1_;
#line 100 "../src/process.vala"
		self->priv->_app_id_checked = TRUE;
#line 1648 "process.c"
	}
#line 103 "../src/process.vala"
	_tmp2_ = self->priv->_app_id;
#line 103 "../src/process.vala"
	result = _tmp2_;
#line 103 "../src/process.vala"
	return result;
#line 1656 "process.c"
}

static void
usage_process_class_init (UsageProcessClass * klass,
                          gpointer klass_data)
{
#line 21 "../src/process.vala"
	usage_process_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/process.vala"
	g_type_class_adjust_private_offset (klass, &UsageProcess_private_offset);
#line 21 "../src/process.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_process_get_property;
#line 21 "../src/process.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_process_set_property;
#line 21 "../src/process.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_process_finalize;
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_PID_PROPERTY, usage_process_properties[USAGE_PROCESS_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CMDLINE_PROPERTY, usage_process_properties[USAGE_PROCESS_CMDLINE_PROPERTY] = g_param_spec_string ("cmdline", "cmdline", "cmdline", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_UID_PROPERTY, usage_process_properties[USAGE_PROCESS_UID_PROPERTY] = g_param_spec_uint ("uid", "uid", "uid", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_START_TIME_PROPERTY, usage_process_properties[USAGE_PROCESS_START_TIME_PROPERTY] = g_param_spec_uint64 ("start-time", "start-time", "start-time", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CGROUP_PROPERTY, usage_process_properties[USAGE_PROCESS_CGROUP_PROPERTY] = g_param_spec_string ("cgroup", "cgroup", "cgroup", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CPU_LOAD_PROPERTY, usage_process_properties[USAGE_PROCESS_CPU_LOAD_PROPERTY] = g_param_spec_double ("cpu-load", "cpu-load", "cpu-load", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_X_CPU_LOAD_PROPERTY, usage_process_properties[USAGE_PROCESS_X_CPU_LOAD_PROPERTY] = g_param_spec_double ("x-cpu-load", "x-cpu-load", "x-cpu-load", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CPU_LAST_USED_PROPERTY, usage_process_properties[USAGE_PROCESS_CPU_LAST_USED_PROPERTY] = g_param_spec_uint64 ("cpu-last-used", "cpu-last-used", "cpu-last-used", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY, usage_process_properties[USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY] = g_param_spec_uint64 ("x-cpu-last-used", "x-cpu-last-used", "x-cpu-last-used", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_LAST_PROCESSOR_PROPERTY, usage_process_properties[USAGE_PROCESS_LAST_PROCESSOR_PROPERTY] = g_param_spec_uint ("last-processor", "last-processor", "last-processor", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_MEM_USAGE_PROPERTY, usage_process_properties[USAGE_PROCESS_MEM_USAGE_PROPERTY] = g_param_spec_uint64 ("mem-usage", "mem-usage", "mem-usage", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_GAMEMODE_PROPERTY, usage_process_properties[USAGE_PROCESS_GAMEMODE_PROPERTY] = g_param_spec_boolean ("gamemode", "gamemode", "gamemode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY, usage_process_properties[USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY] = g_param_spec_boolean ("mark-as-updated", "mark-as-updated", "mark-as-updated", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_STATUS_PROPERTY, usage_process_properties[USAGE_PROCESS_STATUS_PROPERTY] = g_param_spec_enum ("status", "status", "status", USAGE_TYPE_PROCESS_STATUS, USAGE_PROCESS_STATUS_SLEEPING, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_APP_ID_PROPERTY, usage_process_properties[USAGE_PROCESS_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1703 "process.c"
}

static void
usage_process_instance_init (UsageProcess * self,
                             gpointer klass)
{
#line 21 "../src/process.vala"
	self->priv = usage_process_get_instance_private (self);
#line 25 "../src/process.vala"
	self->priv->_start_time = (guint64) 0;
#line 27 "../src/process.vala"
	self->priv->_cgroup_read = FALSE;
#line 40 "../src/process.vala"
	self->priv->_cpu_load = (gdouble) 0;
#line 41 "../src/process.vala"
	self->priv->_x_cpu_load = (gdouble) 0;
#line 42 "../src/process.vala"
	self->priv->_cpu_last_used = (guint64) 0;
#line 43 "../src/process.vala"
	self->priv->_x_cpu_last_used = (guint64) 0;
#line 44 "../src/process.vala"
	self->priv->_last_processor = (guint) 0;
#line 46 "../src/process.vala"
	self->priv->_mem_usage = (guint64) 0;
#line 50 "../src/process.vala"
	self->priv->_mark_as_updated = TRUE;
#line 51 "../src/process.vala"
	self->priv->_status = USAGE_PROCESS_STATUS_SLEEPING;
#line 53 "../src/process.vala"
	self->priv->_app_id = NULL;
#line 54 "../src/process.vala"
	self->priv->_app_id_checked = FALSE;
#line 1736 "process.c"
}

static void
usage_process_finalize (GObject * obj)
{
	UsageProcess * self;
#line 21 "../src/process.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_PROCESS, UsageProcess);
#line 23 "../src/process.vala"
	_g_free0 (self->priv->_cmdline);
#line 28 "../src/process.vala"
	_g_free0 (self->priv->_cgroup);
#line 53 "../src/process.vala"
	_g_free0 (self->priv->_app_id);
#line 21 "../src/process.vala"
	G_OBJECT_CLASS (usage_process_parent_class)->finalize (obj);
#line 1753 "process.c"
}

static GType
usage_process_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageProcess), 0, (GInstanceInitFunc) usage_process_instance_init, NULL };
	GType usage_process_type_id;
	usage_process_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageProcess", &g_define_type_info, 0);
	UsageProcess_private_offset = g_type_add_instance_private (usage_process_type_id, sizeof (UsageProcessPrivate));
	return usage_process_type_id;
}

GType
usage_process_get_type (void)
{
	static volatile gsize usage_process_type_id__once = 0;
	if (g_once_init_enter (&usage_process_type_id__once)) {
		GType usage_process_type_id;
		usage_process_type_id = usage_process_get_type_once ();
		g_once_init_leave (&usage_process_type_id__once, usage_process_type_id);
	}
	return usage_process_type_id__once;
}

static void
_vala_usage_process_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	UsageProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_PROCESS, UsageProcess);
#line 21 "../src/process.vala"
	switch (property_id) {
#line 21 "../src/process.vala"
		case USAGE_PROCESS_PID_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_int (value, usage_process_get_pid (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_CMDLINE_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_string (value, usage_process_get_cmdline (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_UID_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_uint (value, usage_process_get_uid (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_START_TIME_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_start_time (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_CGROUP_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_string (value, usage_process_get_cgroup (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_CPU_LOAD_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_double (value, usage_process_get_cpu_load (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LOAD_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_double (value, usage_process_get_x_cpu_load (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_CPU_LAST_USED_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_cpu_last_used (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_x_cpu_last_used (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_LAST_PROCESSOR_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_uint (value, usage_process_get_last_processor (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_MEM_USAGE_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_mem_usage (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_GAMEMODE_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_boolean (value, usage_process_get_gamemode (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_boolean (value, usage_process_get_mark_as_updated (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_STATUS_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_enum (value, usage_process_get_status (self));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_APP_ID_PROPERTY:
#line 21 "../src/process.vala"
		g_value_set_string (value, usage_process_get_app_id (self));
#line 21 "../src/process.vala"
		break;
#line 1878 "process.c"
		default:
#line 21 "../src/process.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/process.vala"
		break;
#line 1884 "process.c"
	}
}

static void
_vala_usage_process_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	UsageProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_PROCESS, UsageProcess);
#line 21 "../src/process.vala"
	switch (property_id) {
#line 21 "../src/process.vala"
		case USAGE_PROCESS_PID_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_pid (self, g_value_get_int (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_CMDLINE_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_cmdline (self, g_value_get_string (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_UID_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_uid (self, g_value_get_uint (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_START_TIME_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_start_time (self, g_value_get_uint64 (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_CPU_LOAD_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_cpu_load (self, g_value_get_double (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LOAD_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_x_cpu_load (self, g_value_get_double (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_CPU_LAST_USED_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_cpu_last_used (self, g_value_get_uint64 (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_x_cpu_last_used (self, g_value_get_uint64 (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_LAST_PROCESSOR_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_last_processor (self, g_value_get_uint (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_MEM_USAGE_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_mem_usage (self, g_value_get_uint64 (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_GAMEMODE_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_gamemode (self, g_value_get_boolean (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_mark_as_updated (self, g_value_get_boolean (value));
#line 21 "../src/process.vala"
		break;
#line 21 "../src/process.vala"
		case USAGE_PROCESS_STATUS_PROPERTY:
#line 21 "../src/process.vala"
		usage_process_set_status (self, g_value_get_enum (value));
#line 21 "../src/process.vala"
		break;
#line 1976 "process.c"
		default:
#line 21 "../src/process.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/process.vala"
		break;
#line 1982 "process.c"
	}
}

static GType
usage_process_status_get_type_once (void)
{
	static const GEnumValue values[] = {{USAGE_PROCESS_STATUS_RUNNING, "USAGE_PROCESS_STATUS_RUNNING", "running"}, {USAGE_PROCESS_STATUS_SLEEPING, "USAGE_PROCESS_STATUS_SLEEPING", "sleeping"}, {USAGE_PROCESS_STATUS_DEAD, "USAGE_PROCESS_STATUS_DEAD", "dead"}, {0, NULL, NULL}};
	GType usage_process_status_type_id;
	usage_process_status_type_id = g_enum_register_static ("UsageProcessStatus", values);
	return usage_process_status_type_id;
}

GType
usage_process_status_get_type (void)
{
	static volatile gsize usage_process_status_type_id__once = 0;
	if (g_once_init_enter (&usage_process_status_type_id__once)) {
		GType usage_process_status_type_id;
		usage_process_status_type_id = usage_process_status_get_type_once ();
		g_once_init_leave (&usage_process_status_type_id__once, usage_process_status_type_id);
	}
	return usage_process_status_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

